#include	<allegro.h>
#include	<string.h>
#include	<ctype.h>
#define	statdef	extern
#include	"newstats.h"

#define	PARTY_DISP F1KEY
#define	TOPSCREEN	197
#define	RTSCREEN	198
#define	LTSCREEN	199
#define	LTEDGE	200
#define	RTEDGE	201
#define	TOPEDGE	202
#define	BOTEDGE	203

#define	LEFT	0
#define	RIGHT	3

#define	NOGO	1
#define	PERIL	2
#define	DARK	4
#define	TALL	8

#define	MAXWORLDS	24
#define	MAXTALKS	134
#define	MAXSPELLS	32
#define	MAXLADS	28
#define	MAXATTACKS	MYLIMIT
#define	LINELEN 156
#define	LINESTART	160
#define	LINECUT	(LINELEN/4)
#define	LINEHALF	(LINELEN/2)
#define	TALKTOP 3
#define	TALKBOT 146
#define	TALKBASE TALKBOT-2
#define	TALKHEIGHT	9
#define	TALKDISP	TALKTOP+TALKHEIGHT-3

/* Item types */
#define	NOTHING 0
#define	FOOD	1
#define	EDIBLE	0
#define	DRINK	1

#define	WEAPON	2
#define	ARMOR	3
#define	SHIELD	4
#define	AMULET	5

#define	WRITTEN 6
#define	NOTICE	0
#define	CAPTION	1

#define	PERSON	7
#define	GUARD	0
#define	SHOP	1
#define	HOSTILE 2
#define	NORM	3
#define	QUESTER 4
#define	BEGGAR	5
#define	INN	6
#define	ORACLE	7
#define	TEMPLE	8
#define	SCHOOL	9
#define	MERCHANT	10
#define	RIDDLER 11
#define	THIEF	12
#define	CASINO	13

#define	LOCK	8
#define	CHEST	0
#define	DOOR	1

#define	MAGICAL	9
#define	SCROLL	0
#define	WAND	1
#define	STAVE	2
#define	POTION	3
#define	SPARE	4

#define	RANDOM	10

/* Spell effects */
#define	LIGHT	1
#define	DARKNESS	2
#define	VIEW	3
#define	RESTORE	4
#define	POISON	5
#define	UNPOISON	6
#define	DISEASE	7
#define	CURING	8
#define	LETHAL	9
#define	REVIVE	10
#define	HURT	11
#define	HEALING	12
#define	WEAKEN	13
#define	STRENGTH	14
#define	SOFTSKIN	15
#define	BARKSKIN	16
#define	SLOW	17
#define	HASTE	18
#define	CURSE	19
#define	BLESS	20
#define	TANGLE	21
#define	LOOSE	22
#define	STARVE	23
#define	FEED	24
#define	RESHAPE	25
#define	TROUBLE	26
#define	BATTLE	27

/* Spell area options */
#define	FIGHT	1
#define	TRAVEL	2
#define	CLUSTER	4
#define	MULTI	8
#define	OTHER	16
#define	SELF	32
#define	ENEMY	64

/* World states */
/* degree of hostility 1 & 2 */
#define	VERTICAL	4
#define	BOUNDED	8
#define	LIGHTING	16

typedef	char	SPEECH[65];

typedef	short	REL[6];

typedef struct  COUNTER {
		STRING	name[25];
		ROTATE	effect;
		UCHAR	power;
		ROTATE	contents;
		ROTATE	text;
		ROTATE 	picture;
		short	fires;
		short	current;
		UCHAR	repeat;	/*whether it resets*/
		ROTATE	field; /*if a fight*/
		FLAG	sets;
		FLAG	unsets;
		COORD	place;
	}	COUNTER;

typedef	struct	TERRAIN {
		UCHAR	sh_no;
		char	t_no;
		UCHAR	type;
		ROTATE	effect;
		ROTATE	m_type;
		char	change_from;
		char	change_to;
		char	time;
		char	level;
      UCHAR	spare;
		char	prev_terr;
		char	bpict;
		short	backcolor;
		UCHAR	count1;
		UCHAR count2;
      FLAG	flags;
	}	TERRAIN;

typedef	struct	GATE {
		COORD	exit;
		COORD	entry;
		char	pretext;
		char	posttext;
	}	GATE;

typedef	struct	WORLD {
		STRING	name[25];
		char	type;
		STRING	mapname[13];
		char	size;
		char	mins;
		UCHAR	states;
		ROTATE	tune;
		ROTATE	backgnd;
      UCHAR	gcount;
      UCHAR	tcount;
      short	icount;
      GATE	*gates;
      TERRAIN	*blocks;
      WITEM	*witems;
	}	WORLD;

typedef	struct	TALK {
		SPEECH	lines[16];
	}	TALK;

typedef	struct TREAS {
		STRING	name[10];
		STRING	plural[12];
		long	spellbook;
		short	hitems[20];
		short	hicosts[20];
		UCHAR	hicounts[20];
	}	TREAS;

typedef	struct	SPELL {
		STRING	name[25];
		ROTATE	effect;
		UCHAR	cost;
		UCHAR	power;
		STRING	verb[14];
		char	range;
		UCHAR	locales;
	}	SPELL;

typedef	struct FIGHTER {
		unsigned	short	hits;
		unsigned	short	protection;
		unsigned	short	cover;
		unsigned	short	shield;
		unsigned	short	skill;
		unsigned	short	speed;
		unsigned	short	magres;
		short	vigor;
		UCHAR	state;
		UCHAR	sex;
		long	spells;
		char	*name;
		UCHAR	sprite;
		UCHAR	face;
		short	power;
		unsigned	short	act_pt;
		UCHAR	action;
		UCHAR	morale;
		UCHAR	spell;
		UCHAR	mobile;
		UCHAR	target;
		UCHAR	x;
		UCHAR	y;
		UCHAR	side;
		UCHAR	effect;
		UCHAR	verb;
	}	FIGHTER;

typedef	struct	PC {
		STRING	name[25];
		ROTATE	picture;
		unsigned	short	mhits;
		unsigned	short	mprotection;
		unsigned	short	mcover;
		unsigned	short	mshield;
		unsigned	short	mskill;
		unsigned	short	mspeed;
		unsigned	short	mmagres;
		short	vigor;
		UCHAR	state; /*1 Poi 2 Dis 4 Hun*/
		UCHAR	sex;
		long	spellbook;
		char	*fname;
		UCHAR	sprite;
		UCHAR	fatigue;
		UCHAR	strength;
		UCHAR	endurance;
		UCHAR	dexterity;
		UCHAR	intelligence;
		short	purse;
		short	load;
		UCHAR	hits;
		UCHAR	protection;
		UCHAR	cover;
		UCHAR	shield;
		UCHAR	power;
		UCHAR	skill;
		UCHAR	speed;
		UCHAR	waste;
		short	mload;
		UCHAR	weightrat;
		UCHAR	skillrat;
		UCHAR	speedrat;
		UCHAR	hitrat;
		UCHAR	strplus;
		UCHAR	endplus;
		UCHAR	dextplus;
		UCHAR	intplus;
		UCHAR	strrat;
		UCHAR	endrat;
		UCHAR	dextrat;
		UCHAR	intrat;
		long	experience;
		ITEM	right;
		ITEM	left;
		ITEM	wear;
		ITEM	amulet;
		ITEM	ring;
		ITEM	bracers;
		ITEM	bp[14];
	}	PC;

#define	BLOCK	0
#define	ADDON	1
#define	LDOOR	2
#define	UDOOR	3
#define	RDOOR	4
#define	FLOOR	5

#define	SICK	3
#define	POISONED	2
#define	DISEASED	1
#define	HUNGRY	4


#define	align(i)	(167+((i)*TALKHEIGHT))

dundef	short	mx, my, active, hitter, pal_change, is_dark, bigpic,
	res, cell, tlength, wcount, hcount, rcount, tokt, level,
	hex, oldhex, buying, event_ahead, lighting, noisy, currnumber,
	sceneidx[55], cols_used, oldinview, fieldcols[15],
	minute, hour, day, month, year, head, w_no, slow, printx,
	prayed, gatecount, terrcount, hitcount, loseit, intalk,
	introuble, party_no, mapsize, war, mapoff, letpx[8], 
	oldstats[4][7], oldback, newback, batpre, batmap, 
	batface, batstuck, viewmouse, changeface, whyt, blood, vert, 
	svert, framecol, batmul, timer, changeframe, paltotal, sncontrol, wrcount;

dundef	int	explev, ladskill[MAXLADS], laddefence[MAXLADS];
dundef	FLAG	flags;

dundef	char	saves[10][25], *fplurals[3], *newscreen,
	gamesave[FMSIZE], effects[FMSIZE],
   maps[FMSIZE], statics[FMSIZE], am_names[3][8],
	*atlas, *map, face, nomouse, startgame;

dundef	UCHAR	wallf[21][32], *filepalette, mp_volume;

dundef	int	textidx[MAXTALKS], picidx[100], bacidx[MYLIMIT];
	
dundef	FDB	letsrc;

extern	REL	rels[], w_rels[];

extern	PXY	scenepx, textpx, printpx;
dundef	char	wallbuff[25508], fieldmaps[15][462];
dundef	char	backgnd[152*128], msg[256], brush[576];

dundef	TALK	texts[MAXTALKS], *talk;
dundef	TREAS	*holdings, *currtreas;
dundef	COUNTER	counters[32];

dundef	COORD	here, nextstep, blocks[16];

dundef	PC	party[4], *currpc;

dundef	WORLD	*wcurr, world[MAXWORLDS];

dundef	ITEM	*currnpc, *curritem, *currbody, *currobject;

dundef	SPELL	spellbook[MAXSPELLS], *currspell;

dundef	FIGHTER lads[MAXLADS], *actor, *target;

dundef	SPEECH	*speech;

dundef	GATE	*gates;

dundef	TERRAIN	*terrains[48];

dundef	MONSTER	*randoms, *wrandoms[128];

dundef	GFONT	*fonthd;

extern	char	faces[6][8];
extern	unsigned	short	my_font[], meece[3][36], compass[6][36];
extern	unsigned	char	goth[];
extern	FDB	dummy, display, draws, *textfdb;
