#include	<allegro.h>
#include	<string.h>
#include	<ctype.h>
#include	<unistd.h>
#include	"hexrsr.h"
#define	statdef	extern
#include	"newstats.h"

#define MAXWITEMS	72
#define MAXWGATES	48
#define MAXTERRAINS	48
#define MAXWORLDS	32
#define MAXTALKS	256
#define MAXTREAS	128
#define MAXRANDOMS  128
#define MAXSPELLS	32
#define MAXITYPES	MYLIMIT
#define MAXSUBTYPES MYLIMIT
#define MAXFLAGS	16
#define MAXWTYPES	MYLIMIT
#define MAXATTACKS  MYLIMIT

#define BLOCK	0
#define ADDON	1
#define LDOOR	2
#define UDOOR	3
#define RDOOR	4
#define FLOOR	5

typedef struct  COUNTER {
		STRING  name[25];
		ROTATE effect;
		UCHAR		power;
		ROTATE  contents;
		ROTATE  text;
		ROTATE  picture;
		short	fires;
		short	current;
		UCHAR	repeat;	/*whether it resets*/
		ROTATE	field; /*if a fight*/
      FLAG	sets;
      FLAG	unsets;
		COORD	place;
	}	COUNTER;

typedef	struct	GATE {
		COORD	exit;
		COORD	entry;
		char	entrytext;
		char	exittext;
	}	GATE;

typedef	struct	TERRAIN {
		UCHAR	sh_no;
		char	t_no;
		UCHAR	type;
		ROTATE	effect;
		ROTATE	m_type;
		char	change_from;
		char	change_to;
		char	time;
		char	level;
      UCHAR	spare;
		char	prev_terr;
		char	bpict;
		short	backcolor;
		UCHAR	count1;
		UCHAR count2;
      FLAG	flags;
	}	TERRAIN;

typedef struct	WORLD {
		STRING	name[25];
      ROTATE	type;
		STRING	mapname[13];
		char	size;
		char	mins;
		UCHAR	states;
		ROTATE	tune;
		ROTATE	backgnd;
		GATE	gates[MAXWGATES];
		TERRAIN	blocks[MAXTERRAINS];
      WITEM	conlocs[MAXWITEMS];
	}	WORLD;

typedef	struct	TALK {
		char	used[18];
		STRING	lines[16][65];
	}	TALK;

typedef struct	TREAS {
		STRING	name[10];
		STRING	plural[12];
		long	spellbook;
		short	hitems[20];
		short	hicosts[20];
		UCHAR	hicounts[20];
	}	TREAS;

typedef	struct	SPELL {
		STRING	name[25];
		ROTATE	effect;
		char	cost;
		char	power;
		STRING	verb[14];
		char	range;
		UCHAR	locales;
	}	SPELL;
   
#define	LEFT	0
#define	RIGHT	3

#define	NOGO	1
#define	PERIL	2
#define	DARK	4
#define	TALL	8

#define	NOTHING	0
#define	FOOD	1
#define	WEAPON	2
#define	ARMOR	3
#define	SHIELD	4
#define	AMULET	5
#define	PERSON	7
#define	HOSTILE	2
#define	LOCK	8
#define	CHEST	1
#define	MAGICAL	9
#define	SCROLL	0
#define	FIGHTER	10

typedef short	REL[6];

dundef  COORD	here, nextstep, new, blocks[16];

dundef	short	currpict, button, mx, my, cell,
	msgbuff[8], px[8], icount, wcount, currworld, tcount, currtext, hcount,
	inimake, rcount, xitems, yitems, hitems, witems, tokt, mapsize, hex,
	oldhex, w_second, w_items, contstart,
	treasbuff[16], armbuff[6], block, blockx, blocky, tochange,
	deftype, subtypect[MAXSUBTYPES], wtypect, flagct,
	songct, subto, spellct, sub2to, attack,
	r_areas[MAXWTYPES], wline, wcol, tline, tline_pos, cncount,
	xpic, ypic, wpic, hpic, xview, startday,
	yview, wview, hview;

dundef	char	wlines[16][65], folders[7][37],
   lists[FMSIZE], hexdir[FMSIZE],
   pictures[FMSIZE], maps[FMSIZE], reports[FMSIZE], screens[FMSIZE],
   savedir[FMSIZE], *line_used;

dundef	UCHAR	*area, copy[HEXSIZE], orig[HEXSIZE];

extern	REL	rels[HEXSIZE], w_rels[108];
extern	short	coords[][4], wcoords[][4];
extern	char	faces[6][8];

dundef	PXY	fudge; 

dundef	TALK	*tcurr, texts[MAXTALKS];
dundef	WORLD	*wcurr, worlds[MAXWORLDS];
dundef	TREAS	*hcurr, holdings[MAXTREAS];
dundef	MONSTER	*rcurr, randoms[MAXRANDOMS];
dundef	COUNTER	counters[32];
dundef	char	backplane[19456];

dundef	OBJECT	*menu, *contents, *d_worlds, *d_items, *d_texts, *d_textbox,
	*d_randoms, *d_holdings, *connections, *blocktypes, *d_spells, *helpbox,
   *pictbox, *d_counters, *viewbox, *d_glob, *isubtypes, *wsubtypes;

dundef	ITEM *icurr, *hright;

dundef	SPELL	spellbook[MAXSPELLS];
extern	short	etypect, attct, itypect;
extern	char	effects[][9], peffects[][5], r_temps[][10],
	wtypes[MAXWTYPES][10], areas[MAXWTYPES][8][14], i_temps[][10],
   flag_names[MAXFLAGS][26], itypes[][10], isubs[MAXITYPES][MAXSUBTYPES][10],
   bigmap[FNSIZE], smallmap[FNSIZE], midmap[FNSIZE], arenamap[FNSIZE],
   scenery[FNSIZE], hostlevels[][5], hextypes[][8];
