#define dundef
#include	"newgen.h"
#include	<sys/stat.h>

#define	HIDEBOX	(HIDETREE|DISABLED)

char	macrolist[][12] = { "NAME", "ITYPES", "SUBTYPES", "WORLDS",
	"AREAS", "TIMES", "FLAGS", "ATTACKS", "MUSIC", "FOLDERS",
	"VARIABLES", "MONTHS", "SCREENS" };

void	show_rvars();

extern	void	enobj(OBJECT *), disobj(OBJECT *);

void load_items() {
	fp=fopen("items", "rb");
	fread(&icount, 2, 1, fp);
	fread(items, sizeof(ITEM), icount, fp);
	fclose(fp);
}

void load_holdings() {
	fp=fopen("holdings", "rb");
	fread(&hcount, 2, 1, fp);
	fread(holdings, sizeof(TREAS), hcount, fp);
	fclose(fp);
}

void load_counters() {
	fp=fopen("counters", "rb");
	fread(counters, sizeof(COUNTER), 32, fp);
	fclose(fp);
	cncount=32;
}
	
void load_randoms() {
	if(fp=fopen("monsters", "rb")) {
		fread(&rcount, 2, 1, fp);
		fread(&randoms, sizeof(MONSTER), rcount, fp);
		fclose(fp);
	}
}

void load_worlds() {
short i, l;
UCHAR j, k;
WORLD *world;
TERRAIN terrain;
char mess[32];
	world=worlds;
	fp=fopen("worlds", "rb");
	fread(&wcount, 2, 1, fp);
	i=0; while(i<wcount) {
		fread(world, 44, 1, fp);
		fread(&j, 1, 1, fp);
		fread(&k, 1, 1, fp);
		fread(&l, 2, 1, fp);
		fread(world->gates, sizeof(GATE), j, fp);
		while(j<MAXWGATES) world->gates[j++].exit.cell=HEXSIZE;
		while(k--) {
			fread(&terrain, sizeof(TERRAIN), 1, fp);
			world->blocks[(int)terrain.t_no]=terrain;
		}
		fread(&world->conlocs, sizeof(WITEM), l, fp);
		i++; world++;
	}
	fclose(fp);
}

void save_all() {
short i, j, k, l, count;
char *buffer;
WORLD *world;
	save_global();
	chdir(lists);
	fp=fopen("items", "wb");
	fwrite(&icount, 2, 1, fp);
	fwrite(items, sizeof(ITEM), icount, fp);
	fclose(fp);
	if(tcount) {
		fp=fopen("texts", "wb");
		tcurr=texts; i=0; while(i<tcount) {
			fwrite(&tcurr->used[16], 1, 1, fp);
			count=0; while(count<16) {
				if(tcurr->used[count]) {
					fwrite(&count, 1, 1, fp);
					buffer=tcurr->lines[count]; 
					while(*buffer) *(buffer++)^=255;
					buffer=tcurr->lines[count];
					fwrite(buffer, strlen(buffer)+1, 1, fp);
				}
				count++;
			}
			i++; tcurr++;
		}
		fclose(fp);
	}
	if(spellct) {
		fp=fopen("spells", "wb");
		fwrite(&spellct, 2, 1, fp);
		fwrite(&spellbook, sizeof(SPELL), spellct, fp);
		fclose(fp);
	}
	fp=fopen("counters", "wb");
	fwrite(&counters, sizeof(COUNTER), 32, fp);
	fclose(fp);
	fp=fopen("worlds", "wb");
	fwrite(&wcount, 2, 1, fp);
	world=worlds; i=0; while(i<wcount) {
		fwrite(world, 44, 1, fp);
		count=j=0; while(count<MAXWGATES) {
			if(world->gates[count].exit.cell<HEXSIZE) j++;
			count++;
		}
		fwrite(&j, 1, 1, fp);
		count=k=1; while(count<48) {
			if(world->blocks[count].t_no==count) k++;
			count++;
		}
		fwrite(&k, 1, 1, fp);
		count=l=0; while(count<MAXWITEMS) {
			if(world->conlocs[count].count) l++;
			count++;
		}
		fwrite(&l, 2, 1, fp);
		count=0; while(count<MAXWGATES) {
			if(world->gates[count].exit.cell<HEXSIZE)
				fwrite(&world->gates[count], sizeof(GATE), 1, fp);
			count++;
		}
		count=0; while(count<48) {
			if(world->blocks[count].t_no==count) 
				fwrite(&world->blocks[count], sizeof(TERRAIN), 1, fp);
			count++;
		}
		count=0; while(count<MAXWITEMS) {
			if(world->conlocs[count].count)
				fwrite(&world->conlocs[count], sizeof(WITEM), 1, fp);
			count++;
		}
		i++; world++;
	}
	fclose(fp);
	fp=fopen("holdings", "wb");
	fwrite(&hcount, 2, 1, fp);
	fwrite(&holdings, sizeof(TREAS), hcount, fp);
	fclose(fp);
	fp=fopen("monsters", "wb");
	fwrite(&rcount, 2, 1, fp);
	i=0; while(i<hcount) {
		j=0; while(j<rcount) {
			if(randoms[j].contents==i)
				fwrite(&randoms[j], sizeof(MONSTER), 1, fp);
			j++;
		}
		i++;
	}
	fclose(fp);
}

void show_states(OBJECT *flags, short states) {
short i=0;
	while(i<8) {
		if(states&(1<<i)) flags[i].ob_flags|=SELECTED;
		else flags[i].ob_flags&=~SELECTED;
		i++;
	}
}

void show_flags(OBJECT *flags, FLAG flag) {
	show_states(flags, flag);
	show_states(&flags[8], flag>>8);
}

void view_sprite(char current) {
short i, j, k, l, m, n;
PXY spritepx;
char *block=alloca(2304), *orig;
FDB bits;
	Forcepalette(0, sprcol, spalette);
	Setscreen(1, 0); v_clrwk(handle);
	bits.fd_addr=block;
	spritepx[0]=spritepx[1]=i=0; while(i<sprct) {
		m=spritesizes[i]&63; l=m*2;
		spritepx[2]=spritepx[3]=l-1;
		bits.fd_h=bits.fd_w=l;
		spritepx[4]=(i%13)*49;
		spritepx[5]=(i/13)*48+((spritesizes[i]&128)?0:48-l);
		spritepx[6]=spritepx[4]+spritepx[2];
		spritepx[7]=spritepx[5]+spritepx[3];
		orig=&sprites[i][m*m*3]; j=k=0; while(j<m*m) {
			n=orig[j]; if(!n&&i==current) n=1;
			block[k]=block[k+1]=block[k+l]=block[k+l+1]=n;
			j++; k+=2; if(!(j%m)) k+=l;
		}
		screenblit(S_ONLY, spritepx, &bits);
		i++;
	}
	Setscreen(0, 0);
	get_choice();
	if(mx>636) mx=636;
	currpict=(mx/49)+((my/48)*13);
	if(currpict>=sprct) currpict=-1;
	v_clrwk(handle);
}

void add_item(short *curritem, short n) {
short i;
	if(icount>=MAXITEMS) { form_error_text("Too many items"); return; }
	switch(n) {
		case 2:
			i=6; while(i<20) {
				if(!hcurr->hicounts[i]) break;
				i++;
			}
			if(i==20) { form_error_text("No room in bag"); return; }
			items[icount]=*icurr;
			hcurr->hitems[i]=icount;
			hcurr->hicounts[i]=hcurr->hicounts[*curritem];
			*curritem=i; icount++;
			break;
		case 1:
			i=0; while(i<MAXWITEMS) {
				if(!wcurr->conlocs[i].count) break;
				i++;
			}
			if(i==MAXWITEMS) { form_error_text("World full"); return; }
			items[icount]=*icurr;
			wcurr->conlocs[i]=wcurr->conlocs[*curritem];
			wcurr->conlocs[i].item=icount;
			*curritem=i; icount++;
			break;
		default:
			items[icount]=*icurr; *curritem=icount++;
	}
}

void do_items(short n, short nitem) {
short curritem, i, j, currcount, type, *hit;
ITEM *regit;
OBJECT *rdial;
UCHAR *vars;
TREAS *temptreas;
char *temps;
	curritem=nitem;
	rdial=d_items;
	form_show(rdial, &xitems, &yitems, &witems, &hitems);
	switch(n) {
		case 0:
			if((curritem=do_contents(9))<0) return;
			rdial[I_STRING].ob_spec="General Items";
				rdial[I_DEL].ob_spec="Lose";
				rdial[I_LIST].ob_spec="List";
				rdial[I_ITNO].ob_flags|=HIDETREE;
				rdial[I_COORD].ob_flags|=HIDETREE;
				disedobj(&rdial[I_COST]);
				disedobj(&rdial[I_COUNT]);
		 break;
		case 1:
			rdial[I_STRING].ob_spec=wcurr->name;
			rdial[I_DEL].ob_spec="Clear";
			rdial[I_LIST].ob_spec="Place";
			rdial[I_ITNO].ob_flags&=~HIDETREE;
			rdial[I_COORD].ob_flags&=~HIDETREE;
			edobj(&rdial[I_COST]);
			edobj(&rdial[I_COUNT]);
			currcount=MAXWITEMS; break;
		default:
			currcount=20; temptreas=hcurr;
			hit=temptreas->hitems;
			rdial[I_STRING].ob_spec=temptreas->name;
			rdial[I_DEL].ob_spec="Doff";
			rdial[I_LIST].ob_spec="Don";
			rdial[I_ITNO].ob_flags&=~HIDETREE;
			rdial[I_COORD].ob_flags|=HIDETREE;
			edobj(&rdial[I_COST]);
			edobj(&rdial[I_COUNT]);
	}
	while(1) {
		switch(n) {
			case 0: currcount=icount;
				icurr=&items[curritem]; break;
			case 1:
				sprintf(((TEDINFO *)rdial[I_ITNO].ob_spec)->te_ptext, "%3d",
					wcurr->conlocs[curritem].item);
				icurr=&items[wcurr->conlocs[curritem].item]; break;
			default:
				sprintf(((TEDINFO *)rdial[I_ITNO].ob_spec)->te_ptext, "%3d",
					hit[curritem]);
				icurr=&items[hit[curritem]];
		}
		regit=icurr;
		vars=&(regit->hits);
		type=regit->type;
		if(type==PERSON||type==FIGHTER) {
			rdial[I_PERSON].ob_flags&=~HIDETREE;
			((TEDINFO *)rdial[I_SEX].ob_spec)->te_ptext=
				(regit->backuse) ? "Female" : "Male";
			((TEDINFO *)rdial[I_VERB].ob_spec)->te_ptext=
				attacks[regit->locales];
			sprintf(((TEDINFO *)rdial[I_BATTYPE].ob_spec)->te_ptext, "%3d",
				regit->battlefield);
			rdial[I_END].ob_flags&=~HIDETREE;
			rdial[I_DEX].ob_flags&=~HIDETREE;
			rdial[I_INT].ob_flags&=~HIDETREE;
			rdial[I_CODE].ob_flags|=EXIT;
			rdial[I_CODE].ob_type=R_FTEXT;
			rdial[I_USE].ob_flags|=HIDETREE;
			rdial[I_HIDEMAG].ob_flags|=HIDETREE;
			temps=(char *)r_temps;
		}
		else {
			rdial[I_PERSON].ob_flags|=HIDETREE;
			rdial[I_END].ob_flags|=HIDETREE;
			rdial[I_DEX].ob_flags|=HIDETREE;
			rdial[I_INT].ob_flags|=HIDETREE;
			rdial[I_CODE].ob_flags&=~EXIT;
			rdial[I_CODE].ob_type=R_ETEXT;
			rdial[I_USE].ob_flags&=~HIDETREE;
			rdial[I_HIDEMAG].ob_flags&=~HIDETREE;
			temps=(char *)i_temps;
		}
		sprintf(((TEDINFO *)rdial[I_COST].ob_spec)->te_ptmplt,
			"%s: ____GP", temps);
		sprintf(((TEDINFO *)rdial[I_WEIGHT].ob_spec)->te_ptmplt,
			"%s: ____", (char *)&temps[10]);
		i=2; while(i<19) {
			if(i<16)
				sprintf(((TEDINFO *)rdial[I_COST+i].ob_spec)->te_ptmplt,
					"%s: ___", (char *)&temps[i*10]);
			if(i>3)
				sprintf(((TEDINFO *)rdial[I_COST+i].ob_spec)->te_ptext,
					"%3d", vars[i-4]);
			i++;
		}
		sprintf(((TEDINFO *)rdial[I_NO].ob_spec)->te_ptext, "%3d",
			curritem);
		sprintf(((TEDINFO *)rdial[I_COST].ob_spec)->te_ptext, "%4d",
			regit->cost);
		sprintf(((TEDINFO *)rdial[I_WEIGHT].ob_spec)->te_ptext, "%4d",
			regit->weight);
		sprintf(((TEDINFO *)rdial[I_USE].ob_spec)->te_ptext, "%3d",
			regit->use);
		sprintf(((TEDINFO *)rdial[I_COUNT].ob_spec)->te_ptext, "%3d",
			regit->count);
		sprintf(((TEDINFO *)rdial[I_PIC].ob_spec)->te_ptext, "%2d",
			currpict=regit->picture);
		sprintf(((TEDINFO *)rdial[I_TEXT].ob_spec)->te_ptext, "%3d",
			regit->text);
		((TEDINFO *)rdial[I_NAME].ob_spec)->te_ptext=regit->name;
		((TEDINFO *)rdial[I_EFFECT].ob_spec)->te_ptext=
			(type==PERSON) ? peffects[(regit->effect<3)?regit->effect:0] : effects[regit->effect];
		((TEDINFO *)rdial[I_TYPE].ob_spec)->te_ptext=itypes[type];
		((TEDINFO *)rdial[I_CONTENTS].ob_spec)->te_ptext=
			holdings[regit->contents].name;
		show_states(&rdial[I_COND1], (short)regit->locales);
		show_flags(&rdial[I_FLAGS1], regit->doflags);
		show_flags(&rdial[I_UNFLAGS1], regit->dontflags);
		((TEDINFO *)rdial[I_SUB].ob_spec)->te_ptext=
			(char *)isubs[type][regit->subtype];
		if(n==1) {
			sprintf(((TEDINFO *)rdial[I_HEX].ob_spec)->te_ptext, "%3d",
				(short)wcurr->conlocs[curritem].hex);
			sprintf(((TEDINFO *)rdial[I_CELL].ob_spec)->te_ptext, "%3d",
				(short)wcurr->conlocs[curritem].cell);
			sprintf(((TEDINFO *)rdial[I_COUNT].ob_spec)->te_ptext, "%3d",
				wcurr->conlocs[curritem].count);
			sprintf(((TEDINFO *)rdial[I_USE].ob_spec)->te_ptext, "%3d",
				wcurr->conlocs[curritem].used);
		}
		else if(n==2) {
			sprintf(((TEDINFO *)rdial[I_COST].ob_spec)->te_ptext, "%4d",
				(short)temptreas->hicosts[curritem]);
			sprintf(((TEDINFO *)rdial[I_COUNT].ob_spec)->te_ptext, "%3d",
				(short)temptreas->hicounts[curritem]);
		}
		do_form(rdial, xitems, yitems, witems, hitems);
		regit->weight=atoi(((TEDINFO *)rdial[I_WEIGHT].ob_spec)->te_ptext);
		if(n==2) {
			temptreas->hicosts[curritem]=
				atoi(((TEDINFO *)rdial[I_COST].ob_spec)->te_ptext);
			temptreas->hicounts[curritem]=
				atoi(((TEDINFO *)rdial[I_COUNT].ob_spec)->te_ptext);
		}
		if(n&1) {
			wcurr->conlocs[curritem].hex=atoi(((TEDINFO *)rdial[I_HEX].ob_spec)->te_ptext);
			wcurr->conlocs[curritem].cell=atoi(((TEDINFO *)rdial[I_CELL].ob_spec)->te_ptext);
			wcurr->conlocs[curritem].count=atoi(((TEDINFO *)rdial[I_COUNT].ob_spec)->te_ptext);
			wcurr->conlocs[curritem].used=atoi(((TEDINFO *)rdial[I_USE].ob_spec)->te_ptext);
		}
		i=0; while(i<15) {
			vars[i]=atoi(((TEDINFO *)rdial[I_HITS+i].ob_spec)->te_ptext);
			i++;
		}
		if(!(regit->type==PERSON||regit->type==FIGHTER)) {
			regit->backuse=regit->use=
				atoi(((TEDINFO *)rdial[I_USE].ob_spec)->te_ptext);
			regit->backeating=regit->eating;
		}
		else regit->use=regit->count;
		if(button>=I_COND1&&button<I_COND1+8)
			regit->locales^=(1<<(button-I_COND1));
		else switch(button) {
			case I_QUIT:
				if(n&&regit->name[0]&&!regit->count) regit->count=1;
				if(n==2) hcurr=temptreas;
				form_close(xitems, yitems, witems, hitems);
				return;
			case I_TYPE: if((i=do_contents(5))>=0) {
					regit->type=i;
					if(regit->subtype>=subtypect[regit->type])
						regit->subtype=0;
					}
				break;
			case I_SUB: junk=subtypect[type];
				if((i=do_contents(6))>=0) regit->subtype=i;
				break;
			case I_TEXT: do_texts(regit->text); regit->text=currtext;
				break;
			case I_EFFECT: if((i=do_contents((type==PERSON)?20:2))>=0)
				regit->effect=i;
				break;
			case I_FLAGS:
				while((i=do_contents(1, (long)regit->doflags))>=0)
					regit->doflags^=1<<i;
				break;
			case I_UNFLAGS: 
				while((i=do_contents(1, (long)regit->dontflags))>=0)
					regit->dontflags^=1<<i;
				break;
			case I_SEX: regit->backuse&=1; regit->backuse^=1; break;
			case I_VERB: if((i=do_contents(13))>=0) regit->locales=i;
				break;
			case I_BATTYPE: if((i=do_contents(12))>=0) {
					regit->battlefield=i;
					if(i) do_arena(i-1, &wcurr->conlocs[curritem]);
				}
				break;
			case I_CONTENTS: i=curritem;
				regit->contents=do_treas(regit->contents);
				curritem=i; break;
			case I_PIC:
				regit->picture=view_pict(0, 0);
				break;
			case I_CODE: view_sprite(regit->code); 
				if(currpict>=0) regit->code=currpict;
				break;
			case I_NEXT: if(++curritem==currcount) curritem=0;
				break;
			case I_PREV: if(--curritem<0) curritem=currcount-1;
				break;
			case I_NEW: add_item(&curritem, n);
				break;
			case I_LIST:
				if((i=do_contents(9, 0))>=0) {
					switch(n) {
						case 1: wcurr->conlocs[curritem].item=i;
							wcurr->conlocs[curritem].count=1;
							wcurr->conlocs[curritem].used=items[i].backuse;
							break;
						case 2: hcurr->hitems[curritem]=i;
							hcurr->hicounts[curritem]=1;
							break;
						default: curritem=i;
					}
				}
				break;
			case I_DEL: if(del_check()) {
				if((!n)&&curritem&&icount>1) {
					currcount--;
					i=0; while(i<hcount) {
						foewear=holdings[i].hitems; j=0; while(j<20) {
							if(*foewear==curritem) *foewear=0;
							else if(*foewear==currcount) *foewear=curritem;
							j++; foewear++;
						}
						i++;
					}
					i=0; while(i<wcount) {
						j=0; while(j<MAXWITEMS) {
							if(worlds[i].conlocs[j].item==curritem)
								memset(&worlds[i].conlocs[j], 0, sizeof(WITEM));
							else if(worlds[i].conlocs[j].item==currcount)
								worlds[i].conlocs[j].item=curritem;
							j++;
						}
						i++;
					}
					if(curritem==--icount) curritem--;
					else *regit=items[icount];
				}
				else {
					if(n==1) memset(&wcurr->conlocs[curritem], 0, sizeof(WITEM));
					else hit[curritem]=temptreas->hicounts[curritem]=0;
					form_close(xitems, yitems, witems, hitems);
					return;
				}
				break;
			}
		}
	}
}

short do_counters() {
short currcounter, i, x, y, w, h;
COUNTER *regit;
OBJECT *rdial;
	currcounter=do_contents(4, 0l);
	if(currcounter<0) return(32);
	rdial=d_counters;
	form_show(rdial, &x, &y, &w, &h);
	while(1) {
		regit=&counters[currcounter];
		if(regit->effect) rdial[CN_POWER].ob_flags&=~HIDETREE;
		else rdial[CN_POWER].ob_flags|=HIDETREE;
		((TEDINFO *)rdial[CN_NAME].ob_spec)->te_ptext=regit->name;
		sprintf(((TEDINFO *)rdial[CN_NO].ob_spec)->te_ptext, "%2d",
			currcounter);
		sprintf(((TEDINFO *)rdial[CN_FIRES].ob_spec)->te_ptext, "%5d",
			regit->fires);
		sprintf(((TEDINFO *)rdial[CN_CURRENT].ob_spec)->te_ptext, "%5d",
			regit->current);
		sprintf(((TEDINFO *)rdial[CN_REPEAT].ob_spec)->te_ptext, "%3d",
			regit->repeat);
		((TEDINFO *)rdial[CN_CONTENTS].ob_spec)->te_ptext=
			holdings[regit->contents].name;
		sprintf(((TEDINFO *)rdial[CN_PICTURE].ob_spec)->te_ptext, "%2d",
			currpict=regit->picture);
		sprintf(((TEDINFO *)rdial[CN_TEXT].ob_spec)->te_ptext, "%3d",
			regit->text);
		sprintf(((TEDINFO *)rdial[CN_FIELD].ob_spec)->te_ptext, "%2d",
			regit->field);
		((TEDINFO *)rdial[CN_EFFECT].ob_spec)->te_ptext=effects[regit->effect];
		sprintf(((TEDINFO *)rdial[CN_POWER].ob_spec)->te_ptext, "%3d",
			regit->power);
		((TEDINFO *)rdial[CN_WORLD].ob_spec)->te_ptext=
			(regit->place.world<wcount)?worlds[regit->place.world].name:"Anywhere";
		sprintf(((TEDINFO *)rdial[CN_HEX].ob_spec)->te_ptext, "%3d",
			regit->place.hex);
		sprintf(((TEDINFO *)rdial[CN_CELL].ob_spec)->te_ptext, "%3d",
			regit->place.cell);
		show_flags(&rdial[CN_SET1], regit->sets);
		show_flags(&rdial[CN_UNSET1], regit->unsets);
		do_form(rdial, x, y, w, h);
		regit->fires=atoi(((TEDINFO *)rdial[CN_FIRES].ob_spec)->te_ptext);
		regit->current=atoi(((TEDINFO *)rdial[CN_CURRENT].ob_spec)->te_ptext);
		regit->repeat=atoi(((TEDINFO *)rdial[CN_REPEAT].ob_spec)->te_ptext);
		regit->power=atoi(((TEDINFO *)rdial[CN_POWER].ob_spec)->te_ptext);
		regit->place.hex=atoi(((TEDINFO *)rdial[CN_HEX].ob_spec)->te_ptext);
		regit->place.cell=atoi(((TEDINFO *)rdial[CN_CELL].ob_spec)->te_ptext);
		if(button>=CN_UNSET1&&button<CN_UNSET1+8)
						regit->unsets^=(1<<(button-CN_UNSET1));
		else switch(button) {
			case CNT_QUIT:
				form_close(x, y, w, h);
				return(currcounter);
			case CN_TEXT: do_texts(regit->text); regit->text=currtext;
				break;
			case CN_EFFECT: if((i=do_contents(2))>=0)
				regit->effect=i;
				break;
			case CN_SET:
				while((i=do_contents(1, (long)regit->sets))>=0)
					regit->sets^=1<<i;
				break;
			case CN_UNSET: 
				while((i=do_contents(1, (long)regit->unsets))>=0)
					regit->unsets^=1<<i;
				break;
			case CN_FIELD: if((i=do_contents(12))>=0) regit->field=i;
				break;
			case CN_CONTENTS: regit->contents=do_treas(regit->contents);
				break;
			case CN_PICTURE: regit->picture=view_pict(0, 0); break;
			case CN_WORLD: if((i=do_contents(8))>=0) {
					regit->place.world=i; regit->place.cell=HEXSIZE;
					regit->place.hex=worlds[i].size;
					}
				else regit->place.world=wcount;
					break;
			case CNT_NEXT: currcounter++; currcounter&=31; break;
			case CNT_PREV: currcounter--; currcounter&=31; break;
			case CN_LIST: if((i=do_contents(4))>=0) currcounter=i; break;
			case CN_COPY: i=0; while(i<32) {
					if(!counters[i].name[0]) break;
					i++;
				}
				if(i<32) {
					currcounter=i; counters[i]=*regit;
				}
				break;
			case CN_CLEAR: if(del_check()) {
					memset(regit, 0, sizeof(COUNTER));
					regit->place.world=wcount; regit->place.cell=HEXSIZE;
				}
				break;
		}
	}
}

void do_wsubs(short currtype) {
short i, x, y, w, h;
OBJECT *rdial=wsubtypes;
	form_show(rdial, &x, &y, &w, &h);
	rdial[WS_Title].ob_spec=wtypes[currtype];
	i=0; while(i<8) {
		((TEDINFO *)rdial[WS_Sub1+i].ob_spec)->te_ptext=
			areas[currtype][i];
		i++;
	}
	do_form(rdial, x, y, w, h);
	form_close(x, y, w, h);
	r_areas[currtype]=8;
	while(!areas[currtype][r_areas[currtype]-1][0])
		r_areas[currtype]--;
}

void do_isubs(short currtype) {
short i, x, y, w, h;
OBJECT *rdial=isubtypes;
	form_show(rdial, &x, &y, &w, &h);
	rdial[IS_Title].ob_spec=wtypes[currtype];
	i=0; while(i<MYLIMIT) {
		((TEDINFO *)rdial[IS_Sub1+i].ob_spec)->te_ptext=
			isubs[currtype][i];
		i++;
	}
	do_form(rdial, x, y, w, h);
	form_close(x, y, w, h);
	subtypect[currtype]=8;
	while(!isubs[currtype][subtypect[currtype]-1][0])
		subtypect[currtype]--;
}

char *unhome(char *folder) {
short i=strlen(home);
	if(!strncmp(folder, home, i)) return(&folder[i]);
#ifdef LINUX
	return(folder);
#elsif
	return(&folder[2]);
#endif
}

void do_global() {
short i, picked, x, y, w, h;
OBJECT *rdial;
	rdial=d_glob;
	form_show(rdial, &x, &y, &w, &h);
	picked=N_Tunes;
	while(1) {
		rdial[picked].ob_flags|=SELECTED;
		if(picked==N_Tunes) {
			rdial[N_TuneBox].ob_flags&=~HIDEBOX;
			rdial[N_FlagBox].ob_flags|=HIDEBOX;
			rdial[N_VarBox].ob_flags|=HIDEBOX;
			rdial[N_MonthBox].ob_flags|=HIDEBOX;
			rdial[N_ScreenBox].ob_flags|=HIDEBOX;
			rdial[N_WTypeBox].ob_flags|=HIDEBOX;
			rdial[N_ITypeBox].ob_flags|=HIDEBOX;
			rdial[N_AttackBox].ob_flags|=HIDEBOX;
			rdial[N_FolderBox].ob_flags|=HIDEBOX;
		}
		else if(picked==N_ITypes) {
			rdial[N_ITypeBox].ob_flags&=~HIDEBOX;
			rdial[N_FlagBox].ob_flags|=HIDEBOX;
			rdial[N_TuneBox].ob_flags|=HIDEBOX;
			rdial[N_VarBox].ob_flags|=HIDEBOX;
			rdial[N_MonthBox].ob_flags|=HIDEBOX;
			rdial[N_ScreenBox].ob_flags|=HIDEBOX;
			rdial[N_WTypeBox].ob_flags|=HIDEBOX;
			rdial[N_AttackBox].ob_flags|=HIDEBOX;
			rdial[N_FolderBox].ob_flags|=HIDEBOX;
		}
		else if(picked==N_Folders) {
			rdial[N_FolderBox].ob_flags&=~HIDEBOX;
			rdial[N_ITypeBox].ob_flags|=HIDEBOX;
			rdial[N_FlagBox].ob_flags|=HIDEBOX;
			rdial[N_TuneBox].ob_flags|=HIDEBOX;
			rdial[N_VarBox].ob_flags|=HIDEBOX;
			rdial[N_MonthBox].ob_flags|=HIDEBOX;
			rdial[N_ScreenBox].ob_flags|=HIDEBOX;
			rdial[N_WTypeBox].ob_flags|=HIDEBOX;
			rdial[N_AttackBox].ob_flags|=HIDEBOX;
		}
		else if(picked==N_WTypes) {
			rdial[N_WTypeBox].ob_flags&=~HIDEBOX;
			rdial[N_FlagBox].ob_flags|=HIDEBOX;
			rdial[N_TuneBox].ob_flags|=HIDEBOX;
			rdial[N_VarBox].ob_flags|=HIDEBOX;
			rdial[N_MonthBox].ob_flags|=HIDEBOX;
			rdial[N_ScreenBox].ob_flags|=HIDEBOX;
			rdial[N_ITypeBox].ob_flags|=HIDEBOX;
			rdial[N_AttackBox].ob_flags|=HIDEBOX;
			rdial[N_FolderBox].ob_flags|=HIDEBOX;
		}
		else if(picked==N_Screens) {
			rdial[N_ScreenBox].ob_flags&=~HIDEBOX;
			rdial[N_TuneBox].ob_flags|=HIDEBOX;
			rdial[N_FlagBox].ob_flags|=HIDEBOX;
			rdial[N_VarBox].ob_flags|=HIDEBOX;
			rdial[N_MonthBox].ob_flags|=HIDEBOX;
			rdial[N_WTypeBox].ob_flags|=HIDEBOX;
			rdial[N_ITypeBox].ob_flags|=HIDEBOX;
			rdial[N_AttackBox].ob_flags|=HIDEBOX;
			rdial[N_FolderBox].ob_flags|=HIDEBOX;
		}
		else if(picked==N_Attacks) {
			rdial[N_AttackBox].ob_flags&=~HIDEBOX;
			rdial[N_TuneBox].ob_flags|=HIDEBOX;
			rdial[N_VarBox].ob_flags|=HIDEBOX;
			rdial[N_MonthBox].ob_flags|=HIDEBOX;
			rdial[N_ScreenBox].ob_flags|=HIDEBOX;
			rdial[N_WTypeBox].ob_flags|=HIDEBOX;
			rdial[N_ITypeBox].ob_flags|=HIDEBOX;
			rdial[N_FlagBox].ob_flags|=HIDEBOX;
			rdial[N_FolderBox].ob_flags|=HIDEBOX;
		}
		else if(picked==N_Flags) {
			rdial[N_FlagBox].ob_flags&=~HIDEBOX;
			rdial[N_TuneBox].ob_flags|=HIDEBOX;
			rdial[N_VarBox].ob_flags|=HIDEBOX;
			rdial[N_MonthBox].ob_flags|=HIDEBOX;
			rdial[N_ScreenBox].ob_flags|=HIDEBOX;
			rdial[N_WTypeBox].ob_flags|=HIDEBOX;
			rdial[N_ITypeBox].ob_flags|=HIDEBOX;
			rdial[N_AttackBox].ob_flags|=HIDEBOX;
			rdial[N_FolderBox].ob_flags|=HIDEBOX;
		}
		else if(picked==N_MonthNames) {
			rdial[N_MonthBox].ob_flags&=~HIDEBOX;
			rdial[N_TuneBox].ob_flags|=HIDEBOX;
			rdial[N_FlagBox].ob_flags|=HIDEBOX;
			rdial[N_VarBox].ob_flags|=HIDEBOX;
			rdial[N_ScreenBox].ob_flags|=HIDEBOX;
			rdial[N_WTypeBox].ob_flags|=HIDEBOX;
			rdial[N_ITypeBox].ob_flags|=HIDEBOX;
			rdial[N_AttackBox].ob_flags|=HIDEBOX;
			rdial[N_FolderBox].ob_flags|=HIDEBOX;
			i=0; while(i<months)
				rdial[N_Month1+i++].ob_flags&=~DISABLED;
			while(i<16)
				rdial[N_Month1+i++].ob_flags|=DISABLED;
		}
		else if(picked==N_Variables) {
			rdial[N_VarBox].ob_flags&=~HIDEBOX;
			rdial[N_TuneBox].ob_flags|=HIDEBOX;
			rdial[N_FlagBox].ob_flags|=HIDEBOX;
			rdial[N_MonthBox].ob_flags|=HIDEBOX;
			rdial[N_ScreenBox].ob_flags|=HIDEBOX;
			rdial[N_WTypeBox].ob_flags|=HIDEBOX;
			rdial[N_ITypeBox].ob_flags|=HIDEBOX;
			rdial[N_AttackBox].ob_flags|=HIDEBOX;
			rdial[N_FolderBox].ob_flags|=HIDEBOX;
			sprintf(((TEDINFO *)rdial[N_StartExp].ob_spec)->te_ptext,
				"%7d", explev);
			sprintf(((TEDINFO *)rdial[N_StartHour].ob_spec)->te_ptext,
				"%2d", starthour);
			sprintf(((TEDINFO *)rdial[N_StartDay].ob_spec)->te_ptext,
				"%2d", startday);
			((TEDINFO *)rdial[N_StartMonth].ob_spec)->te_ptext=
				m_names[startmonth];
			sprintf(((TEDINFO *)rdial[N_StartYear].ob_spec)->te_ptext,
				"%4d", startyear);
			sprintf(((TEDINFO *)rdial[N_Hostile].ob_spec)->te_ptext,
				"%2d", hostility);
			sprintf(((TEDINFO *)rdial[N_Vicious].ob_spec)->te_ptext,
				"%2d", vicious);
			sprintf(((TEDINFO *)rdial[N_Quick].ob_spec)->te_ptext,
				"%2d", quickfight);
			sprintf(((TEDINFO *)rdial[N_Slow].ob_spec)->te_ptext,
				"%4d", slowfight);
			sprintf(((TEDINFO *)rdial[N_Minutes].ob_spec)->te_ptext,
				"%2d", minutes);
			sprintf(((TEDINFO *)rdial[N_Hours].ob_spec)->te_ptext,
				"%2d", hours);
			sprintf(((TEDINFO *)rdial[N_Days].ob_spec)->te_ptext,
				"%2d", days);
			sprintf(((TEDINFO *)rdial[N_Months].ob_spec)->te_ptext,
				"%2d", months);
			sprintf(((TEDINFO *)rdial[N_Camp].ob_spec)->te_ptext,
				"%2d", bed);
			sprintf(((TEDINFO *)rdial[N_Wake].ob_spec)->te_ptext,
				"%2d", wake);
		}
		do_form(rdial, x, y, w, h);
		if(picked==N_Variables) {
			explev=
				atoi(((TEDINFO *)rdial[N_StartExp].ob_spec)->te_ptext);
			starthour=
				atoi(((TEDINFO *)rdial[N_StartHour].ob_spec)->te_ptext);
			startday=
				atoi(((TEDINFO *)rdial[N_StartDay].ob_spec)->te_ptext);
			startyear=
				atoi(((TEDINFO *)rdial[N_StartYear].ob_spec)->te_ptext);
			hostility=
				atoi(((TEDINFO *)rdial[N_Hostile].ob_spec)->te_ptext);
			vicious=
				atoi(((TEDINFO *)rdial[N_Vicious].ob_spec)->te_ptext);
			quickfight=
				atoi(((TEDINFO *)rdial[N_Quick].ob_spec)->te_ptext);
			slowfight=
				atoi(((TEDINFO *)rdial[N_Slow].ob_spec)->te_ptext);
			minutes=
				atoi(((TEDINFO *)rdial[N_Minutes].ob_spec)->te_ptext);
			hours=
				atoi(((TEDINFO *)rdial[N_Hours].ob_spec)->te_ptext);
			days=
				atoi(((TEDINFO *)rdial[N_Days].ob_spec)->te_ptext);
			months=
				atoi(((TEDINFO *)rdial[N_Months].ob_spec)->te_ptext);
			if(startmonth>=months) startmonth=0;
			bed=
				atoi(((TEDINFO *)rdial[N_Camp].ob_spec)->te_ptext);
			wake=
				atoi(((TEDINFO *)rdial[N_Wake].ob_spec)->te_ptext);
		}
		if(button>=N_Tune1&&button<N_Tune1+12) {
			strcpy(selfile, "*.mid"); strcpy(handy, pictures);
			fsel_exinput(handy, selfile, &i, "Pick a Midi");
			if(i) strcpy(songs[button-N_Tune1], selfile);
		}
		if(button>=N_Folder1&&button<N_Folder1+7) {
			strcpy(selfile, "*.*"); strcpy(handy, home);
			fsel_exinput(handy, selfile, &i, "Pick a Folder");
			if(i) {
				switch(button-N_Folder1) {
					case 0: strcpy(lists, handy); break;
					case 1: strcpy(pictures, handy); break;
					case 2: strcpy(maps, handy); break;
					case 3: strcpy(shapes, handy); break;
					case 4: strcpy(reports, handy); break;
					case 5: strcpy(screens, handy); break;
					case 6: strcpy(savedir, handy);
				}
				strcpy(folders[button-N_Folder1], unhome(handy));
			}
		}
		else if(button>=N_SmallMap&&button<N_SmallMap+5) {
			strcpy(selfile, "*.pcx"); strcpy(handy, screens);
			fsel_exinput(handy, selfile, &i, "Pick a Screen");
			if(i) {
				switch(button) {
					case N_SmallMap:
						strcpy(smallmap, selfile); break;
					case N_MidMap:
						strcpy(midmap, selfile); break;
					case N_BigMap:
						strcpy(bigmap, selfile); break;
					case N_Arena:
						strcpy(arenamap, selfile); break;
					case N_Scenery:
						strcpy(scenery, selfile); break;
				}
			}
		}
		else if(button>=N_WT1Subs&&button<N_WT1Subs+MYLIMIT)
			do_wsubs(button-N_WT1Subs);
		else if(button>=N_IT1Subs&&button<N_IT1Subs+11)
			do_isubs(button-N_IT1Subs);
		else switch(button) {
			case N_Quit:
				rdial[picked].ob_flags&=~SELECTED;
				songct=12;
				while(!songs[songct-1][0]) songct--;
				flagct=MAXFLAGS;
				while(!flag_names[flagct-1][0]) flagct--;
				attack=16;
				while(!attacks[attack-1][0]) attack--;
				wtypect=MYLIMIT;
				while(!wtypes[wtypect-1][0]) wtypect--;
				form_close(x, y, w, h);
				return;
			case N_StartMonth: i=do_contents(25);
				if(i>=0) startmonth=i;
				break;
			case N_Tunes:
			case N_Flags:
			case N_MonthNames:
			case N_ITypes:
			case N_Screens:
			case N_WTypes:
			case N_Attacks:
			case N_Folders:
			case N_Variables:
				rdial[picked].ob_flags&=~SELECTED;
				picked=button;
				break;
		}
	}
}

void wlist(char *type) {
short i, j=R_FLAG1, k=R_WORLD1, l=0;
	while(l<4) {
		i=0; if(!type[1])
			((TEDINFO *)d_randoms[k].ob_spec)->te_ptext="Spare";
		else { 
			((TEDINFO *)d_randoms[k].ob_spec)->te_ptext=wtypes[*type];
			show_states(&d_randoms[j], (short)type[1]);
			while(i<r_areas[*type]) {
				sprintf((char *)d_randoms[j].ob_spec, "%.3s",
					areas[*type][i++]);
				d_randoms[j++].ob_flags&=~HIDETREE;
			}
		}
		while(i++<8) d_randoms[j++].ob_flags|=HIDETREE;
		type+=2; k++; l++;
	}
}

void do_randoms() {
short currrandom, i, new, old, xrand, yrand, wrand, hrand;
UCHAR *j, temp[4];
MONSTER *r, orig;
OBJECT *rdial;
char *type;
	  if(!rcount) {
		  strcpy(randoms[0].name, "Bogy"); rcount=1;
	  }
	if((currrandom=do_contents(15))<0) return;
	rdial=d_randoms; new=(rcount==1);
	form_show(rdial, &xrand, &yrand, &wrand, &hrand);
	while(1) {
		r=rcurr=&randoms[currrandom]; j=&r->hits;
		stats=&r->strength; foewear=holdings[r->contents].hitems;
		rats(temp, &items[foewear[0]], &items[foewear[1]],
				&items[foewear[2]], 208);
		i=0; while(i<9) {
			if(!new) {
					edobj(&rdial[R_HITS+i]);
				if(i<4) disedobj(&rdial[R_STR+i]);
			}
			else {
					disedobj(&rdial[R_HITS+i]);
				if(i<4) edobj(&rdial[R_STR+i]);
			}
			i++;
		}
		if(new) {
			rdial[R_GEN].ob_spec="Random Changer";
			rdial[R_NEXT].ob_spec="Show";
			rdial[R_QUIT].ob_spec="KEEP";
			disobj(&rdial[R_EXP]);
			rdial[R_LIST].ob_flags|=HIDETREE;
			rdial[R_PREV].ob_flags|=HIDETREE;
			rdial[R_NEW].ob_flags|=HIDETREE;
		}
		else {
			rdial[R_GEN].ob_spec="Random Editor";
			rdial[R_NEXT].ob_spec="Next";
			rdial[R_QUIT].ob_spec="QUIT";
			enobj(&rdial[R_EXP]);
			rdial[R_LIST].ob_flags&=~HIDETREE;
			rdial[R_PREV].ob_flags&=~HIDETREE;
			rdial[R_NEW].ob_flags&=~HIDETREE;
		}
	i=0; while(i<10) {
		sprintf(((TEDINFO *)rdial[R_HITS+i].ob_spec)->te_ptext,
			"%3d", j[i]);
		i++;
	}
	sprintf(((TEDINFO *)rdial[R_EXP].ob_spec)->te_ptext, "%3d", r->expvalue);
	sprintf(((TEDINFO *)rdial[R_SPRITE].ob_spec)->te_ptext, "%3d", r->sprite);
	i=*temp+1;
	sprintf(((TEDINFO *)rdial[R_DEF].ob_spec)->te_ptext,
		"%6d", r->cover*i+((r->shield*i)>>1)+((r->protection*i)>>2));
	sprintf(((TEDINFO *)rdial[R_WSK].ob_spec)->te_ptext,
		"%6d", r->skill*(temp[1]+1));
	sprintf(((TEDINFO *)rdial[R_WSP].ob_spec)->te_ptext,
		"%6d", r->speed*(temp[2]+1));
	sprintf(((TEDINFO *)rdial[R_WHT].ob_spec)->te_ptext,
		"%6d", r->hits*(temp[3]+1));
	i=0; while(i<4) {
		sprintf(((TEDINFO *)rdial[R_STR+i].ob_spec)->te_ptext,
			"%3d", stats[i]);
		sprintf(((TEDINFO *)rdial[R_WRAT+i].ob_spec)->te_ptext,
			"%3d", temp[i]);
		i++;
	}
		sprintf(((TEDINFO *)rdial[R_NO].ob_spec)->te_ptext, "%3d",
			currrandom);
		sprintf(((TEDINFO *)rdial[R_PURSE].ob_spec)->te_ptext, "%3d",
			r->purse);
		sprintf(((TEDINFO *)rdial[R_FREQ].ob_spec)->te_ptext, "%3d",
			r->frequency);
		sprintf(((TEDINFO *)rdial[R_COUNT].ob_spec)->te_ptext, "%3d",
			r->count);
		((TEDINFO *)rdial[R_BACKPACK].ob_spec)->te_ptext=
			holdings[r->contents].name;
		wlist(r->areas);
		((TEDINFO *)rdial[R_NAME].ob_spec)->te_ptext=r->name;
		((TEDINFO *)rdial[R_SEX].ob_spec)->te_ptext=
			(r->sex) ? "Female" : "Male";
		((TEDINFO *)rdial[R_EFFECT].ob_spec)->te_ptext=
			effects[r->effect];
		((TEDINFO *)rdial[R_VERB].ob_spec)->te_ptext=
			attacks[r->verb];
		do_form(rdial, xrand, yrand, wrand, hrand);
		r->purse=atoi(((TEDINFO *)rdial[R_PURSE].ob_spec)->te_ptext);
		r->count=atoi(((TEDINFO *)rdial[R_COUNT].ob_spec)->te_ptext);
		r->frequency=min(atoi(((TEDINFO *)rdial[R_FREQ].ob_spec)->te_ptext), 255);
		r->type=FIGHTER;
		if(new) {
			r->expvalue=i=0; while(i<4) {
				stats[i]=atoi(((TEDINFO *)rdial[R_STR+i].ob_spec)->te_ptext);
				r->expvalue+=stats[i++];
			}
		 foevig(r, holdings[r->contents].spellbook);
		 r->mobility=
			atoi(((TEDINFO *)rdial[R_MOBILE].ob_spec)->te_ptext);
		}
		else {
			i=0; while(i<10) {
				j[i]=
					min(atoi(((TEDINFO *)rdial[R_HITS+i].ob_spec)->te_ptext), 255);
				i++;
			}
			r->expvalue=atoi(((TEDINFO *)rdial[R_EXP].ob_spec)->te_ptext);
		}
		if(button>=R_FLAG1) {
			i=button-R_FLAG1;
			r->areas[((i>>2)&6)+1]^=(1<<(i&7));
		}
		else if(button>=R_WORLD1) {
			type=r->areas+((button-R_WORLD1)<<1);
			if((i=do_contents(3))>=0) {
				*type=i; type[1]=1;
			}
		}
		else switch(button) {
			case R_GEN: new=1; orig=*r; break;
			case R_VERB: if((i=do_contents(13))>=0) r->verb=i;
				break;
			case R_EFFECT: if((i=do_contents(2))>=0) r->effect=i;
				break;
			case R_BACKPACK:
				r->contents=do_treas(r->contents); break;
			case R_SEX: r->sex^=1; break;
			case R_SPRITE: view_sprite(r->sprite); 
				if(currpict>=0) r->sprite=currpict;
				break;
			case R_QUIT:
				if(!new) {
					form_close(xrand, yrand, wrand, hrand);
					return;
				}
				if(new==2) rcount++;
				new=0; break;
			case R_NEXT:
				if(!new) {
					if(++currrandom==rcount) currrandom=0;
				}
				break;
			case R_PREV: if(!currrandom) currrandom=rcount;
				currrandom--; break;
			case R_LIST: if((i=do_contents(15))>=0) currrandom=i;
				break;
			case R_NEW: if(rcount<MAXRANDOMS) {
					randoms[rcount]=randoms[old=currrandom];
					currrandom=rcount; new=2;
				}
				break;
			case R_DEL:
				if(rcount>1&&del_check()) {
					if(!new) {
						if(currrandom==--rcount) currrandom--;
						else *r=randoms[rcount];
					}
					else {
						if(new==2) currrandom=old;
						else *r=orig;
						new=0;
					}
				}
		}
	}
}

void load_global() {
short deftype=-1, ind=0, j=0;
char *temp=handy;
int pest;
	strcat(hexdir, selfile);
	fp=fopen(hexdir, "rb");
	while(fgets(sofar=myline, 80, fp)) {
		line_no++;
		while(tokt=next_tok()) {
			if(tokt==1) {
			switch(deftype) {
				case 0: strcpy(gamename, temp); break;
				case 1:
				if(j==itypect) report("item types");
				strcpy(itypes[j++], temp);
				break;
				case 2:
				if(temp[0]=='-') {
					if(subto>itypect) report("subtype categories");
					subtypect[++subto]=0;
				}
				else {
					if(subtypect[subto]==MYLIMIT) report("subtypes");
					strcpy(isubs[subto][subtypect[subto]++], temp);
				}
				break;
				case 3:
				if(wtypect==MYLIMIT) report("world types");
				strcpy(wtypes[wtypect++], temp);
				break;
				case 4:
				if(temp[0]=='-') {
					if(sub2to==wtypect) report("areas for worlds");
					sub2to++;
				}
				else {
					if(r_areas[sub2to]==8) report("areas");
					strcpy(areas[sub2to][r_areas[sub2to]++], temp);
				}
				break;
				case 5: pest=atoi(temp);
					switch(ind) {
						case 0: minutes=pest; break;
						case 1: hours=pest; break;
						case 2: days=pest; break;
						case 3: months=pest; break;
						case 4: bed=pest; break;
						case 5: wake=pest; break;
					}
					ind++; break;
				case 6:
				if(flagct==MAXFLAGS) report("flags");
				strcpy(flag_names[flagct++], temp);
				break;
				case 7:
				if(attack==MAXATTACKS) report("attack verbs");
				strcpy(attacks[attack++], temp);
				break;
				case 8:
				if(songct==MYLIMIT) report("tunes");
				strcpy(songs[songct++], temp);
				break;
				case 9:
					strcpy(folders[ind], temp);
					switch(ind) {
						case 0: folder(lists); break;
						case 1: folder(pictures); break;
						case 2: folder(maps); break;
						case 3: folder(shapes); break;
						case 4: folder(reports); break;
						case 5: folder(screens); break;
						case 6: folder(savedir); break;
						default: report("folders");
					}
					ind++; break;
				case 10: pest=atoi(temp);
					switch(ind) {
						case 0: explev=pest; break;
						case 1: starthour=pest; break;
						case 2: startday=pest; break;
						case 3: startmonth=pest; break;
						case 4: startyear=pest; break;
						case 5: hostility=pest; break;
						case 6: vicious=pest; break;
						case 7: quickfight=pest; break;
						case 8: slowfight=pest;
					}
					ind++; break;
				case 11:
					if(ind==months) report("Months");
					strcpy(m_names[ind++], temp); break;
				case 12:
					switch(ind) {
						case 0: strcpy(smallmap, handy); break;
						case 1: strcpy(midmap, handy); break;
						case 2: strcpy(bigmap, handy); break;
						case 3: strcpy(arenamap, handy); break;
						case 4: strcpy(scenery, handy); break;
						default: report("screens");
					}
					ind++; break;
				}
			}
			else {
				deftype++; ind=j=0;
				if(strcmp(macrolist[deftype], temp)) report("types");
			}
		}
	}
	fclose(fp);
}

void load_safe() {
short i;
	items=(ITEM *)malloc(MAXITEMS*sizeof(ITEM));
	shapeuse[0]=3;
	shapecount=1; while(shapecount<64) {
	if(shapenames[shapecount][0]) shapeuse[shapecount]=1;
	else { shapecount++; break; }
		shapecount++;
	}
	if(!chdir(pictures)) get_dsnpics();
	chdir(stateffs);
	backct=read_lib(backs, "backs.lib", backct);
	pictct=read_lib(picts, "picts.lib", pictct);
	load_sprites();
	load_texts();
	i=0; while(i<4) d_glob[N_Folder1+i++].ob_flags|=DISABLED;
	i=flagct; while(i<MAXFLAGS) {
		flag_names[i][0]=0;
		d_items[I_FLAGS1+i].ob_flags|=HIDETREE;
		d_items[I_UNFLAGS1+i].ob_flags|=HIDETREE;
		blocktypes[T_FLAGS1+i].ob_flags|=HIDETREE;
		d_counters[CN_SET1+i].ob_flags|=HIDETREE;
		d_counters[CN_UNSET1+i++].ob_flags|=HIDETREE;
	}
}

int grab_out(char *dest, char *message, char *type) {
int fl, init=type[0];
char *grab;
	if(!fselect(dest, message, type)) return(0);
	if(init=='*') init=type[3]+1;
	fp=fopen(handy, "rb");
	fseek(fp, 0, SEEK_END);
	fl=ftell(fp);
	rewind(fp);
	grab=alloca(fl);
	fread(grab, fl, 1, fp);
	fclose(fp);
	chdir(dest);
	switch(init) {
		case 'p': sprintf(selfile, "pict%03d.blt", pictct); break;
		case 'b': sprintf(selfile, "back%03d.blt", backct); break;
		case 'q': sprintf(selfile, "sprit%03d.spr", sprct); break;
		case 'i': init=0; while(init<MAXHEADS) {
				if(!shapeuse[init]) break;
				init++;
			}
			if(init==MAXHEADS) init--;
			sprintf(selfile, "shape%03d.shp", init); break;
		default: strcpy(selfile, "erewhon.map");
	}
	form_input_text(12, "New Name", selfile, "Rename");
	fp=fopen(selfile, "wb");
	fwrite(grab, fl, 1, fp);
	fclose(fp);
	return(1);
}

short handle_menu() {
short i, size, loaded=0, msgbuff[8];
	while(1) {
		evnt_mesag(msgbuff);
		if(msgbuff[0]==MN_SELECTED) {
			menu_tnormal(menu, msgbuff[3], 1);
			menu_bar(menu, 0);
			switch(msgbuff[4]) {
			case M_QUIT: if(loaded) return(0);
				else form_error_text("Nothing to save");
			case M_ABANDON: if(del_check()||!loaded) return(1);
					break;
			case M_ABOUT:
				form_error_text("HexAID|RPG Maker|22/07/01");
				break;
			case M_Global:
				if(loaded) do_global();
				break;
			case M_Create:
				if(!loaded) {
					form_input_text(12, "New .hex", selfile, "Starting design");
					if(strcmp(get_extension(selfile), "hex"))
						strcpy(&selfile[min(8, strlen(selfile))], ".hex");
					strcat(hexdir, selfile);
					strcpy(handy, selfile);
					strcpy(&handy[strlen(handy)-4], ".dsn/");
					strcpy(folders[4], handy);
					folder(reports);
	  #ifdef ALLEGRO_WINDOWS
						  mkdir(reports);
	  #else
						  mkdir(reports, S_IWUSR);
	  #endif
					strcpy(folders[0], handy); strcat(folders[0], "statics/");
					folder(lists); strcat(lists, "statics/"); 
	  #ifdef ALLEGRO_WINDOWS
						  mkdir(lists);
	  #else
						  mkdir(lists, S_IWUSR);
	  #endif
					strcpy(folders[1], handy); strcat(folders[1], "effects/");
					folder(pictures); strcat(pictures, "effects/"); 
	  #ifdef ALLEGRO_WINDOWS
						  mkdir(pictures);
	  #else
						  mkdir(pictures, S_IWUSR);
	  #endif
					strcpy(folders[2], handy); strcat(folders[2], "worlds/");
					folder(maps); strcat(maps, "worlds/");
	  #ifdef ALLEGRO_WINDOWS
						  mkdir(maps);
	  #else
						  mkdir(maps, S_IWUSR);
	  #endif
					strcpy(shapes, pictures); strcpy(folders[3], folders[1]);
					strcpy(folders[6], handy); strcat(folders[6], "saves/");
					folder(savedir); strcat(savedir, "saves/");  
	  #ifdef ALLEGRO_WINDOWS
						  mkdir(savedir);
	  #else
						  mkdir(savedir, S_IWUSR);
	  #endif
					strcpy(folders[5], "screens/");
					strcpy(screens, home); strcat(screens, "screens/");
					flagct=8; songct=3; itypect=11;
					subtypect[0]=subtypect[1]=subtypect[6]=
					subtypect[8]=subtypect[10]=2;
					subtypect[2]=subtypect[9]=5;
					subtypect[3]=subtypect[4]=r_areas[0]=1;
					subtypect[5]=3; subtypect[7]=14;
					wtypect=loaded=attack=1; do_global();
					load_safe();
					memset(items, 0, sizeof(ITEM));
					strcpy(items[0].name, "Nothing"); icount=1;
					strcpy(holdings[0].name, "Unused"); hcount=1;
					i=0; while(i<MAXWGATES)
						worlds[0].gates[i++].exit.cell=HEXSIZE;
					strcpy(worlds[0].name, "Erewhon"); wcount=1;
					strcpy(randoms[0].name, "Bogy"); rcount=1;
					menu_ienable(menu, 4, 1);
					menu_ienable(menu, 5, 1);
					menu_ienable(menu, 6, 1);
				}
				break;
			case M_Load:
				if(!loaded) {
					strcpy(selfile, "*.hex");
					if(!fselect(hexdir, "Load a design", selfile))
						break;
					load_global(); loaded=1;
					load_safe();
					chdir(lists);
					load_items();
					load_holdings();
					load_counters();
					load_worlds();
					load_randoms();
					menu_ienable(menu, 4, 1);
					menu_ienable(menu, 5, 1);
					menu_ienable(menu, 6, 1);
				}
				break;
			case M_WORLD: do_worlds(); break;
			case P_WORLD: print_worlds(); break;
			case Im_World: grab_world(); break;
			case M_ITEM: do_items(0, 0); break;
			case P_ITEM: print_items(); break;
			case Im_Item: grab_item(); break;
			case M_TEXT: do_texts(0); break;
			case P_TEXT: print_texts(); break;
			case Im_Text: grab_text(); break;
			case M_TREASURE: do_treas(MAXTREAS); break;
			case P_TREASURE: print_treas(); break;
			case Im_Baggage: grab_treas(); break;
			case M_RANDOM: do_randoms(); break;
			case P_RANDOM: print_randoms(); break;
			case Im_Random: grab_random(); break;
			case Im_Fighter: grab_fighter(); break;
			case Im_Sprite:
				if(grab_out(pictures, "New Sprite", "*.spr")) {
					Forcepalette(0, sprcol, spalette);
					i=get_1sprite(selfile);
					if(i>=sprct) sprct=i+1;
					sprcol=Grabpalette(spalette);
				}
				break;
			case Im_Pict:
				if(grab_out(pictures, "New Picture", "pict*.blt")) {
					i=atoi(&selfile[4]);
					if(i>=pictct) pictct=i+1;
					get_1pic(picts, selfile, i);
				}
				break;
			case Im_Back:
				if(grab_out(pictures, "New Background", "back*.blt")) {
					i=atoi(&selfile[4]);
					if(i>=backct) backct=i+1;
					get_1pic(backs, selfile, i);
				}
				break;
			case Im_Shape:
				if(grab_out(shapes, "New Shape", "*.shp")) {
					size=strlen(selfile);
					i=atoi(&selfile[size-6]);
					selfile[size-4]=0;
					memcpy(shapenames[i], selfile, size-3);
					shapeuse[i]=2;
					if(shapecount<=i) shapecount=i+1;
				}
				break;
			case Im_Map:
				grab_out(maps, "New Map", "*.map");
				break;
			case M_SPELL: do_spells(); break;
			case P_SPELL: print_spells(); break;
			case M_COUNTERS: do_counters(); break;
			case P_COUNTERS: print_counters(); break;
			case M_TEXTUSE: do_text_use(); break;
			case M_BAG_USE: do_treas_use(); break;
			case M_ITEM_USE: do_item_use(); break;
			case M_MAKEINI: make_ini(); break;
			default: do_pict_use();
			}
			menu_bar(menu, 1);
		}
	}
}

int main() {
short i;
extern unsigned short rscbuff[];
	getcwd(home, FMSIZE); strcat(home, "/");
	strcpy(stateffs, home); strcat(stateffs, "defaults/");
	strcpy(hexdir, home); strcat(hexdir, "design/");
	paldisp=16;
	appl_init(1);
	rsrc_include(rscbuff);
	/*rsrc_load("newgema1.rsr");*/
	rsrc_gaddr(0, MENU, &menu);
	rsrc_gaddr(0, CONTENTS, &contents);
	rsrc_gaddr(0, WORLDS, &d_worlds);
	rsrc_gaddr(0, ITEMS, &d_items);
	rsrc_gaddr(0, TEXTS, &d_texts);
	rsrc_gaddr(0, TEXTBOX, &d_textbox);
	rsrc_gaddr(0, RANDOMS, &d_randoms);
	rsrc_gaddr(0, HOLDINGS, &d_holdings);
	rsrc_gaddr(0, CONNECTIONS, &connections);
	rsrc_gaddr(0, BLOCKS, &blocktypes);
	rsrc_gaddr(0, SPELLS, &d_spells);
	rsrc_gaddr(0, HELP, &helpbox);
	rsrc_gaddr(0, COUNTERS, &d_counters);
	rsrc_gaddr(0, PICTBOX, &pictbox);
	rsrc_gaddr(0, VIEWBOX, &viewbox);
	form_center(viewbox, &xview, &yview, &wview, &hview);
	rsrc_gaddr(0, NEWHEX, &d_glob);
	i=0; while(i<16) {
		((TEDINFO *)d_glob[N_Flag1+i].ob_spec)->te_ptext=
			flag_names[i];
		((TEDINFO *)d_glob[N_Month1+i].ob_spec)->te_ptext=
			m_names[i];
		((TEDINFO *)d_glob[N_Attack1+i].ob_spec)->te_ptext=
			attacks[i];
		if(i<MYLIMIT) {
			((TEDINFO *)d_glob[N_WType1+i].ob_spec)->te_ptext=
				wtypes[i];
			if(i<12) {
				((TEDINFO *)d_glob[N_Tune1+i].ob_spec)->te_ptext=
					songs[i];
				if(i<11) {
					((TEDINFO *)d_glob[N_IType1+i].ob_spec)->te_ptext=
						itypes[i];
					 if(i<7)
						 ((TEDINFO *)d_glob[N_Folder1+i].ob_spec)->te_ptext=
							 folders[i];
				}
			}
		}
		i++;
	}
	((TEDINFO *)d_glob[N_Name].ob_spec)->te_ptext=gamename;
	((TEDINFO *)d_glob[N_SmallMap].ob_spec)->te_ptext=smallmap;
	((TEDINFO *)d_glob[N_MidMap].ob_spec)->te_ptext=midmap;
	((TEDINFO *)d_glob[N_BigMap].ob_spec)->te_ptext=bigmap;
	((TEDINFO *)d_glob[N_Arena].ob_spec)->te_ptext=arenamap;
	((TEDINFO *)d_glob[N_Scenery].ob_spec)->te_ptext=scenery;
	rsrc_gaddr(0, ISubTypes, &isubtypes);
	rsrc_gaddr(0, WSubTypes, &wsubtypes);
	i=0; while(i<1200) {
		((short *)coords)[i]*=2;
		((short *)wcoords)[i]*=2;
		if(i&1) {
			((short *)coords)[i]++;
			((short *)wcoords)[i]++;
			}
		i++;
	}
	graf_mouse(ARROW, 0l);
	menu_bar(menu, 1);
	i=handle_menu();
	if(!i) save_all();
	return(appl_exit());
}
END_OF_MAIN();
