#define	dundef	extern
#include	"newgen.h"

typedef struct {
	char manufacturer;
	char version;
	char encoding;
	char bits_per_pixel;
	short xmin, ymin;
	short xmax, ymax;
	short hres;
	short vres;
	unsigned char palette[48];
	char reserved;
	char colour_planes;
	short bytes_per_line;
	short palette_type;
	char filler[58];
}	PCXHEAD;

int	currcol;

TERRAIN *terrains;

#define VERTICAL	4
#define BOUNDED	8
#define LIGHTING	16

short	face, gate_cell, npc_cell, is_big, fancy, currarena,
	arenacols[15], x, y;
PXY	pictpx	=	{ 0, 0, 151, 127 };
unsigned char arenas[15][21][22], backpal[768];

void	draw_dun();

void my_hide_mouse() { v_hide_c(handle); }

void my_show_mouse() { v_show_c(handle, 1); }

void screenblit(int mode, PXY px, FDB *source) {
	my_hide_mouse();
	vro_cpyfm(handle, mode, px, source, &display);
	my_show_mouse();
}

int get_choice() {
short choice;
	do { vq_mouse(handle, &button, &mx, &my); } while(button);
	while(!button) vq_mouse(handle, &button, &mx, &my);
	while(button) { choice=button; vq_mouse(handle, &button, &mx, &my); }
	return(choice-1);
}

void gtext(int x, int y, const char *text) {
	v_gtext(handle, x, y, text);
}

void spoint(int point) {
	if(point==6) {
		vst_font(handle, 0); vst_color(handle, GREEN);
		vst_effects(handle, THICKENED);
	}
	else {
		vst_font(handle, 1); vst_color(handle, WHITE);
		vst_effects(handle, DOUBLED);
	}
}

void text_btype(char *type, FLAG btype) {
	strcpy(type, "xxxx");
	if(btype&NOGO) type[0]='I';
	if(btype&PERIL) type[1]='P';
	if(btype&DARK) type[2]='D';
	if(btype&TALL) type[3]='H';
}

void exit_lo() {
int blak=0, whyt=-1;
	Setcolor(0, (char *)&whyt); Setcolor(1, (char *)&blak);
	vst_font(handle, 0); vst_effects(handle, 0);
	Setpalette();
}

void enter_lo() {
int blak=0, whyt=-1;
	Setcolor(1, (char *)&whyt); Setcolor(0, (char *)&blak);
	vst_font(handle, 1); vst_effects(handle, DOUBLED);
	Setpalette();
}

void load_map() {
	chdir(maps);
   terrains=worlds[currworld].blocks;
   mapsize=worlds[currworld].size-1;
	if((fp=fopen(worlds[currworld].mapname, "rb"))) {
		fread(&wrld, mapsize+1, HEXSIZE, fp);
		fclose(fp);
	}
	else memset(wrld, 0, (mapsize+1)*HEXSIZE);
}

COORD new_coord(COORD *old, short direction) {
short i, j;
COORD *regnew=&new;
REL *r_old=&w_rels[old->hex];
	direction=(direction+face)%6;
	*regnew=*old;
	j=old->cell;
	i=new.cell=rels[j][direction];
	if(!(wcurr->states&VERTICAL)||(wcurr->states&BOUNDED)) {
		switch(direction) {
			case UP:
				if(i>=j) {
					if(rels[j][LUP]>j) regnew->hex=(*r_old)[LUP];
					else regnew->hex=(*r_old)[RUP];
				}
				break;
			case RUP:
				if(i>j) regnew->hex=(*r_old)[RUP];
				else if(j-i==EDGE*2-1) regnew->hex=(*r_old)[RIGHT];
				break;
			case RDOWN:
				if(i<j) regnew->hex=(*r_old)[RDOWN];
				else if(j-i==-1) regnew->hex=(*r_old)[RIGHT];
				break;
			case DOWN:
				if(i<=j) {
					if(rels[j][LDOWN]<j) regnew->hex=(*r_old)[LDOWN];
					else regnew->hex=(*r_old)[RDOWN];
				}
				break;
			case LDOWN:
				if(i<j) regnew->hex=(*r_old)[LDOWN];
				else if(i-j==2*EDGE-1) regnew->hex=(*r_old)[LEFT];
				break;
			default:
				if(i>j) regnew->hex=(*r_old)[LUP];
				else if(i-j==-1) regnew->hex=(*r_old)[LEFT];
		}
	}
	return(*regnew);
}

void gate_hex() {
	gate_cell=0; while(gate_cell<MAXWGATES) {
		if(*(long *)&wcurr->gates[gate_cell].exit==*(long *)&new)
			break;
		gate_cell++;
	}
	npc_cell=0; while(npc_cell<MAXWITEMS) {
		if(wcurr->conlocs[npc_cell].count&&wcurr->conlocs[npc_cell].cell==
         new.cell&&wcurr->conlocs[npc_cell].hex==new.hex)
         break;
		npc_cell++;
	}
}
 
void blitbit(short j, short i) {
short m;
int n;
FDB bits;
HEADER *local;
	if(!wcurr->blocks[j].sh_no) return;
   m=wcurr->blocks[j].prev_terr;
	if(m&&m<48) blitbit(m, i);
	else if(m==48) {
		m=0; while(m<6) {
			n=wrld[blocks[i].hex][rels[blocks[i].cell][m]];
			if(headers[wcurr->blocks[n].sh_no].type==FLOOR) {
				blitbit(n, i); break;
			}
			m++;
		}
	}
   local=&headers[wcurr->blocks[j].sh_no];
	if(local->pxes[i][2]) {
		bits.fd_w=local->pxes[i][2]+1; bits.fd_h=local->pxes[i][3]+1;
		bits.fd_addr=&local->shapes[local->offsets[i]];
		vro_cpyfm(handle, D_ONLY, local->pxes[i], &bits, &behind);
	}
}

void view() {
short i, j, k, headtype, wstate;
COORD *rbloc=blocks;
	nextstep=rbloc[13]=new_coord(&here, UP);
	gate_hex();
	new_coord(&nextstep, UP); i=(rbloc[9].hex!=new.hex);
	rbloc[9]=new;
	if((wstate=(wcurr->states&(VERTICAL|BOUNDED)))==(VERTICAL|BOUNDED)&&i)
		gate_cell=0;
	memcpy(backplane, base, 19456);
	rbloc[15]=new_coord(&here, LUP);
	rbloc[14]=new_coord(&here, RUP);
	rbloc[12]=new_coord(&rbloc[15], UP);
	rbloc[11]=new_coord(&rbloc[14], UP);
	rbloc[10]=new_coord(&rbloc[12], LUP);
	rbloc[8]=new_coord(&rbloc[11], RUP);
	rbloc[7]=new_coord(&rbloc[12], UP);
	rbloc[6]=new_coord(&rbloc[11], UP);
	rbloc[5]=new_coord(&rbloc[10], UP);
	rbloc[4]=new_coord(&rbloc[9], UP);
	rbloc[3]=new_coord(&rbloc[8], UP);
	rbloc[2]=new_coord(&rbloc[7], UP);
	rbloc[1]=new_coord(&rbloc[6], UP);
	rbloc[0]=new_coord(&rbloc[4], UP);
	i=0; while(i<16) {
		if((j=wrld[rbloc[i].hex][rbloc[i].cell])<48&&j&&
			(rbloc[i].hex==here.hex||wstate==BOUNDED)) {
			headtype=headers[(int)wcurr->blocks[j].sh_no].type;
			if(headtype>=LDOOR&&headtype<FLOOR&&face!=UP&&face!=DOWN) {
				k=(face==LUP||face==RDOWN);
				switch(headtype) {
					case LDOOR: j-=(1+k); break;
					case RDOOR: j-=(!k-k); break;
					default: j+=(2-k);
				}
			}
			blitbit(j, i);
		}
		i++;
	}
	if(npc_cell<MAXWITEMS) {
		strcpy(viewbox[V_ITEM].ob_spec,
         items[wcurr->conlocs[npc_cell].item].name);
		viewbox[V_ITEM].ob_flags&=~DISABLED;
	}
	else {
		strcpy(viewbox[V_ITEM].ob_spec, "Nothing");
		viewbox[V_ITEM].ob_flags|=DISABLED;
	}
	objc_draw(viewbox, V_ITEM, 8, xview, yview, wview, hview);
	if(gate_cell<MAXWGATES) {
		sprintf(viewbox[V_GATE].ob_spec, "Gate %2d", gate_cell);
		viewbox[V_GATE].ob_flags&=~DISABLED;
	}
	else {
		strcpy(viewbox[V_GATE].ob_spec, "No Gate");
		viewbox[V_GATE].ob_flags|=DISABLED;
	}
	objc_draw(viewbox, V_GATE, 8, xview, yview, wview, hview);
	sprintf(viewbox[V_BLOCK].ob_spec, "Block %2d", wrld[here.hex][here.cell]);
	objc_draw(viewbox, V_BLOCK, 8, xview, yview, wview, hview);
	screenblit(3, pictpx, &behind);
}

void load_back() {
short i;
	chdir(pictures);
	point_image(backs[wcurr->backgnd]);
   i=0; while(i<48) {
      if(terrains[i].t_no==i) {
			load_shape(terrains[i].sh_no);
			if(terrains[i].prev_terr<48)
				load_shape(terrains[terrains[i].prev_terr].sh_no);
		}
		i++;
	}
}

void test_world() {
short i, j, x, y, imperv=0;
char *walktext;
	load_back();
	show_image(0, 0, base, 1);
	Setpalette();
   j=Grabpalette(viewpalette);
   memcpy(palette, viewpalette, j*3);
	pictpx[4]=xview; pictpx[5]=yview;
	pictpx[6]=xview+151; pictpx[7]=yview+127;
	form_dial(0, 0, 0, 0, 0, xview, yview, wview, hview);
	walktext=viewbox[V_WALK].ob_spec;
	strcpy(walktext, "WalkThru");
	here=wcurr->gates[0].exit;
	if(here.cell==HEXSIZE) here.hex=here.cell=0;
	i=1;
	sprintf(viewbox[V_HEX].ob_spec, "Hex %3d", here.hex);
	sprintf(viewbox[V_CELL].ob_spec, "Cell %3d", here.cell);
	sprintf(viewbox[V_DIR].ob_spec, "Direction %s", faces[face]);
	objc_draw(viewbox, 0, 8, xview, yview, wview, hview);
	while(1) {
		if(i) {
			view();
			if(i==2) {
				sprintf(viewbox[V_DIR].ob_spec, "Direction %s", faces[face]);
				objc_draw(viewbox, V_DIR, 8, xview, yview, wview, hview);
			}
			i=0;
		}
		button=get_multi();
		if(!button) {
			vq_mouse(handle, &button, &x, &y);
			if(button) {
				while(button) vq_mouse(handle, &button, &x, &y);
				button=objc_find(viewbox, 0, 8, x, y);
			}
		}
		if(button==V_QUIT||button=='q') {
			form_close(xview, yview, wview, hview); break;
		}
		switch(button) {
			case V_UP:
			case UAKEY:
			case 'l':
				if(!((terrains[wrld[nextstep.hex][nextstep.cell]].type
					&NOGO)&imperv)) {
					here=(gate_cell<MAXWGATES&&currworld==wcurr->gates[gate_cell].entry.world)
						?wcurr->gates[gate_cell].entry:nextstep;
					sprintf(viewbox[V_HEX].ob_spec, "Hex %3d", here.hex);
					objc_draw(viewbox, V_HEX, 8, xview, yview, wview, hview);
					sprintf(viewbox[V_CELL].ob_spec, "Cell %3d", here.cell);
					objc_draw(viewbox, V_CELL, 8, xview, yview, wview, hview);
					i=1;
				}
				break;
			case V_WALK:
			case 'w': imperv^=1;
				strcpy(walktext, (imperv)?"RealWall":"WalkThru");
				objc_draw(viewbox, V_WALK, 8, xview, yview, wview, hview);
				break;
			case V_DOWN:
			case DAKEY:
			case ' ': face=(face+3)%6; i=2; break;
			case V_RIGHT:
			case RAKEY:
			case '.': face=(face+1)%6; i=2; break;
			case V_LEFT:
			case LAKEY:
			case ',': face=(face+5)%6; i=2; break;
			case V_ITEM:
			case 'p':
				if(npc_cell<MAXWITEMS) {
					do_items(1, npc_cell);
					Forcepalette(0, j, viewpalette); frame=0;
				}
				break;
			case V_GATE:
			case 'g':
				if(gate_cell<MAXWGATES) do_connections(gate_cell);
				break;
			case V_BLOCK:
			case 'b':
				do_blocktypes(wrld[here.hex][here.cell]);
				Forcepalette(0, j, viewpalette);
				break;
		}
	}
}

static void ReadPcxLine(char *p) {
short n=0, c, d;
	do {
		c=fgetc(fp);
		if(c>0xc0) {
			c&=0x3f; c*=2;
			d=fgetc(fp); if(d) d+=16;
			memset(&p[n], d, c); n+=c;
		}
		else {
			if(c) c+=16;
			p[n++]=c; p[n++]=c;
		}
	}	while(n<640);
	memcpy(&p[640], p, 640);
}

void loadpcx(char *mess) {
short i;
unsigned char *screen;
	currcol=Getpalette();
	chdir(screens);
	fp=fopen(mess, "rb");
	fseek(fp, -768l, SEEK_END);
	fread(&palette[48], 48, 1, fp);
	Forcepalette(16, 48, &palette[48]);
	fseek(fp, sizeof(PCXHEAD), SEEK_SET);
	Setscreen(1, 0); screen=Logbase();
	i=0; while(i++<200) {
		ReadPcxLine(screen); screen+=1280;
	}
	fclose(fp);
	Setscreen(0, 0);
}

short fselect(char *path, char *mode, char *type) {
short but;
	chdir(path); strcpy(handy, path);
	strcpy(selfile, type);
	fsel_exinput(handy, selfile, &but, mode);
	strcat(handy, selfile);
	return(but);
}

void curse(short cell, short face) {
short temp, side;
	side=die(3);
	if(!area[cell]||!area[temp=rels[cell][side+face]]) return;
	area[cell]=0;
	curse(temp, face);
}

void twist() {
	area[cell]=2; curse(cell, 0);
	area[cell]=2; curse(cell, 3);
}

void map_items(short *px) {
short x=px[0]+6-is_big;
short y=px[1]+10-is_big;
	new.cell=cell; spoint(6);
	gate_hex(); if(gate_cell<MAXWGATES) gtext(x, y, "G");
	if(npc_cell<MAXWITEMS)
		gtext(x, y, (items[wcurr->conlocs[npc_cell].item].type==PERSON)?"P":
			(items[wcurr->conlocs[npc_cell].item].type==FIGHTER)?"F":"O");
	spoint(9);
}

void paint() {
PXY px;
	if(is_big) {
		px[0]=(block&1)*88+464; px[1]=(block>>1)*12+42;
		px[2]=px[0]+15; px[3]=px[1]+9;
	}
	else {
		px[0]=(block%3)*104+328; px[1]=((block/3)<<4)+48;
		px[2]=px[0]+21; px[3]=px[1]+13;
	}
	memcpy(&px[4], (is_big) ? &(wcoords[cell]) : &(coords[cell]), 8);
	screenblit(D_ONLY, px, &display);
	if(fancy) map_items(&px[4]);
	area[cell]=(char)block;
}

void show_block() {
PXY px;
	px[0]=blockx; px[1]=blocky; px[4]=520; px[5]=24;
	if(is_big) {
		px[2]=blockx+85; px[3]=blocky+11; px[6]=605; px[7]=35;
	}
	else {
		px[2]=blockx+95; px[3]=blocky+13; px[6]=615; px[7]=36;
	}
	screenblit(3, px, &display);
}

void show_where() {
char mess[12];
	sprintf(mess, "C:%03d H:%03d", cell, hex);
	vst_color(handle, 3);
	gtext(464, 16, mess);
}

void map_btype() {
short i;
TERRAIN *terr;
	spoint(6); terr=wcurr->blocks; i=0; while(i<48) {
		if(terr->t_no!=i) strcpy(handy, "       ");
		else {
			strcpy(handy, shapenames[terr->sh_no]);
			text_btype(&handy[4], terr->type);
		}
		if(is_big) gtext(480+88*(i&1), 50+((i>>1)*12), handy);
		else gtext(354+104*(i%3), 58+((i/3)<<4), handy);
		i++; terr++;
	}
	spoint(9);
}

void map_edit(short option) {
GATE *gate;
unsigned char *oldscreen;
	gate_hex();
	if(gate_cell==MAXWGATES&&npc_cell==MAXWITEMS) {
		if(option) {
			gate=wcurr->gates; gate_cell=0; while(gate_cell<MAXWGATES) {
				if(gate->exit.cell==HEXSIZE) break;
				gate_cell++; gate++;
			}
			if(gate_cell==MAXWGATES) return;
			gate->exit.hex=hex; gate->exit.cell=cell;
			gate->exit.world=currworld;
		}
		else {
         npc_cell=0; while(npc_cell<MAXWITEMS) {
				if(!wcurr->conlocs[npc_cell].count) break;
				npc_cell++;
			}
			if(npc_cell==MAXWITEMS) return;
			wcurr->conlocs[npc_cell].hex=hex;
			wcurr->conlocs[npc_cell].cell=cell;
		}
	}
	Setscreen(1, 0); oldscreen=alloca(255360);
	memcpy(oldscreen, Logbase(), 255360);
	Setscreen(0, 0);
	exit_lo();
	if(gate_cell<MAXWGATES) do_connections(gate_cell);
	else {
		Grabpalette(backpal);
		do_items(1, npc_cell);
		Forcepalette(16, 48, &backpal[48]);
	}
	enter_lo();
	Setscreen(1, 0);
	memcpy(Logbase(), oldscreen, 255360);
	Setscreen(0, 0);
	draw_dun();
}

void toggle_fancy() {
	fancy^=1; my_hide_mouse();
	if(is_big) {
		vst_color(handle, GREEN);
		gtext(466, 377, (fancy) ? "Items" : "Block");
	}
	else {
		vst_color(handle, RED);
		gtext(434, 356, (fancy) ? "Items" : "Block");
	}
	draw_dun();
	my_show_mouse();
}

void get_block(short option) {
short i;
char *oldscreen;
	if(is_big) {
		blockx=mx-((mx-464)%88);
		i=my-42;
		blocky=i-(i%12)+42;
		block=(((blocky-42)/12)<<1)+(blockx-464)/88;
	}
	else {
		blockx=mx-((mx-328)%104);
		blocky=my-((my-48)&15);
		block=((blocky-48)>>4)*3+(blockx-328)/104;
	}
	show_block();
	if(option) {
		Setscreen(1, 0); oldscreen=alloca(255360);
		memcpy(oldscreen, Logbase(), 255360);
		Setscreen(0, 0);
		exit_lo();
      Grabpalette(backpal);
		do_blocktypes(block);
      Forcepalette(16, 48, &backpal[48]);
		enter_lo();
		Setscreen(1, 0);
		memcpy(Logbase(), oldscreen, 255360);
		Setscreen(0, 0);
		map_btype();
	}
	if(fancy) toggle_fancy();
}

void save_hex() { memcpy(orig, area, HEXSIZE); }

void grab_hex() { memcpy(copy, area, HEXSIZE); }

void paste_hex() {
	memcpy(area, copy, HEXSIZE); draw_dun();
}

void clear_hex() {
	save_hex(); memset(area, block, HEXSIZE); draw_dun();
}

void draw_dun() {
short i=cell, j=block;
	Setscreen(1, 0);
	cell=0; while(cell<HEXSIZE) {
		block=area[cell];
		paint(); cell++;
	}
	cell=i; block=j;
	Setscreen(0, 0);
}

void rfill(short next) {
short *links;
	cell=next; paint();
	links=(short *)&rels[next];
	if(area[links[UP]]==tochange) rfill(links[UP]);
	if(area[links[DOWN]]==tochange) rfill(links[DOWN]);
	if(area[links[LUP]]==tochange) rfill(links[LUP]);
	if(area[links[LDOWN]]==tochange) rfill(links[LDOWN]);
	if(area[links[RUP]]==tochange) rfill(links[RUP]);
	if(area[links[RDOWN]]==tochange) rfill(links[RDOWN]);
}

void wpx1(short locbloc, short *locpx) {
	if(locbloc>47) locbloc=0;
	locpx[0]=(locbloc&1)*88+464; locpx[1]=(locbloc>>1)*12+42;
	locpx[2]=locpx[0]+15; locpx[3]=locpx[1]+9;
	screenblit(D_ONLY, locpx, &display);
}

void draw_world(short force) {
short i=cell, locbloc, *locco, *locold=(short *)&w_rels[oldhex],
	locpx[8], *locrel=(short *)&w_rels[hex];
	Setscreen(1, 0);
	cell=0; while(cell<HEXSIZE) {
		locbloc=area[cell];
		locco=wcoords[cell];
		if(force||locbloc!=wrld[oldhex][cell]) {
			memcpy(&locpx[4], locco, 8);
			wpx1(locbloc, locpx);
			if(fancy) map_items(locco);
		}
		if((locpx[4]=locco[0]-280)>=0) {
			locbloc=wrld[locrel[LEFT]][cell];
			if(force||locbloc!=wrld[locold[LEFT]][cell]) {
				locpx[5]=locco[1];
				locpx[6]=locpx[4]+15; locpx[7]=locpx[5]+9;
				wpx1(locbloc, locpx);
			}
		}
		if(cell>9&&(locpx[6]=locco[2]+280)<464) {
			locbloc=wrld[locrel[RIGHT]][cell];
			if(force||locbloc!=wrld[locold[RIGHT]][cell]) {
				locpx[7]=locco[3];
				locpx[4]=locpx[6]-15; locpx[5]=locpx[7]-9;
				wpx1(locbloc, locpx);
			}
		}
		if(cell<144&&(locpx[6]=locco[2]+140)<464
			&&(locpx[7]=locco[3]+180)<401) {
			locbloc=wrld[locrel[RDOWN]][cell];
			if(force||locbloc!=wrld[locold[RDOWN]][cell]) {
				locpx[4]=locpx[6]-15; locpx[5]=locpx[7]-9;
				wpx1(locbloc, locpx);
			}
		}
		if(cell<145&&(locpx[4]=locco[0]-140)>=0
			&&(locpx[7]=locco[3]+180)<401) {
			locbloc=wrld[locrel[LDOWN]][cell];
			if(force||locbloc!=wrld[locold[LDOWN]][cell]) {
				locpx[6]=locpx[4]+15; locpx[5]=locpx[7]-9;
				wpx1(locbloc, locpx);
			}
		}
		if(cell>154&&(locpx[6]=locco[2]+140)<464
			&&(locpx[5]=locco[1]-180)>35) {
			locbloc=wrld[locrel[RUP]][cell];
			if(force||locbloc!=wrld[locold[RUP]][cell]) {
				locpx[4]=locpx[6]-15; locpx[7]=locpx[5]+9;
				wpx1(locbloc, locpx);
			}
		}
		if(cell>155&&(locpx[4]=locco[0]-140)>=0
			&&(locpx[5]=locco[1]-180)>35) {
			locbloc=wrld[locrel[LUP]][cell];
			if(force||locbloc!=wrld[locold[LUP]][cell]) {
				locpx[6]=locpx[4]+15; locpx[7]=locpx[5]+9;
				wpx1(locbloc, locpx);
			}
		}
		cell++;
	}
	oldhex=hex; cell=i;
	Setscreen(0, 0);
}

short check_whex(short ox, short oy) {
short i=0;
	while(i<HEXSIZE) {
		if(ox>=wcoords[i][0]&&ox<=wcoords[i][2]
			&&oy>=wcoords[i][1]&&oy<=wcoords[i][3]) break;
		i++;
	}
	return(i);
}

short change_whex() {
short i;
	if((i=check_whex((short)(mx+280), my))<HEXSIZE) hex=w_rels[hex][LEFT];
	else if((i=check_whex((short)(mx-280), my))<HEXSIZE)
		hex=w_rels[hex][RIGHT];
	else if((i=check_whex((short)(mx-140), (short)(my-180)))<HEXSIZE)
		hex=w_rels[hex][RDOWN];
	else if((i=check_whex((short)(mx+140), (short)(my-180)))<HEXSIZE)
		hex=w_rels[hex][LDOWN];
	else if((i=check_whex((short)(mx+140), (short)(my+180)))<HEXSIZE)
		hex=w_rels[hex][LUP];
	else if((i=check_whex((short)(mx-140), (short)(my+180)))<HEXSIZE)
		hex=w_rels[hex][RUP];
	new.hex=hex; return(i);
}

void fill(short option) {
	my_hide_mouse();
	save_hex();
	if(option) {
		tochange=area[cell]; if(tochange!=block) rfill(cell);
	}
	else paint();
	my_show_mouse();
}

void do_dun() {
short i, j, option;
	draw_dun();
	while(1) {
		option=get_choice();
		if(mx<328) {
			if(my>383&&mapsize) {
				if(mx>79&&mx<102) {
					if(++hex>mapsize) hex=0;
				}
				else if(mx>199&&mx<222) {
					if(--hex<0) hex=mapsize;
				}
				area=wrld[new.hex=hex]; draw_dun(); show_where();
			}
			else if(my>47) {
				i=0; while(i<HEXSIZE) {
					if(mx>=coords[i][0]&&mx<=coords[i][2]&&my>=coords[i][1]
						&&my<=coords[i][3]) break;
					i++;
				}
				if(i<HEXSIZE) {
					new.cell=cell=i;
					if(fancy) map_edit(option);
					else fill(option);
					show_where();
				}
			}
		}
		else if(my>47&&my<321) get_block(option);
		else if(my>369) break;
		else {
			switch((mx-328)/104+((my-324)/20)*3) {
				case 0: twist(); draw_dun(); break;
				case 1: memcpy(area, orig, HEXSIZE); draw_dun(); break;
				case 2: grab_hex(); break;
				case 3: paste_hex(); break;
				case 4: toggle_fancy(); break;
				case 5: if(option) clear_hex();
						else {
							save_hex(); j=cell;
							cell=i=0; while(i<EDGE-1) {
								paint(); cell=rels[cell][LDOWN]; i++;
							}
							i=0; while(i<EDGE) {
								paint(); cell=rels[cell][DOWN]; i++;
							}
							i=0; while(i<EDGE-1) {
								paint(); cell=rels[cell][RDOWN]; i++;
							}
						paint(); cell=j;
					} 
			}
		}
	}
}

void do_wmap() {
short i, option;
	draw_world(1);
	while(1) {
		option=get_choice();
		if(mx<464) {
			if((i=check_whex(mx, my))<HEXSIZE) {
				new.cell=cell=i;
				if(fancy) map_edit(option);
				else fill(option);
			}
			else {
				if((i=change_whex())<HEXSIZE) { 
					cell=i; area=wrld[hex];
					draw_world(0);
				}
			}
			show_where();
		}
		else if(my>41&&my<329) get_block(option);
		else if(my>381) break;
		else {
			switch((mx-464)/88+(((my-336)>>4)<<1)) {
				case 0: twist(); draw_dun(); break;
				case 1: memcpy(area, orig, HEXSIZE); draw_dun(); break;
				case 2: grab_hex(); break;
				case 3: paste_hex(); break;
				case 4: toggle_fancy(); break;
				case 5: if(option) clear_hex(); else draw_dun();
			}
		}
	}
}

void do_map() {
	new.hex=hex=fancy=new.cell=cell=block=0;
	enter_lo();
	area=(char *)wrld;
	if(mapsize>7) {
		is_big=2; loadpcx(bigmap);
		blockx=464; blocky=42;
	}
	else {
		is_big=0; loadpcx((mapsize)?midmap:smallmap);
		blockx=328; blocky=48;
	}
	Setscreen(1, 0);
	map_btype(); show_block(); show_where();
	Setscreen(0, 0);
	if(is_big) do_wmap(); else do_dun();
	exit_lo();
	if(fselect(maps, "Save this map", wcurr->mapname)) {
		fp=fopen(handy, "wb");
		fwrite(&wrld, mapsize+1, HEXSIZE, fp);
		fclose(fp);
      strcpy(wcurr->mapname, selfile);
	}
	v_clrwk(handle);
}

short loadar() {
short i=0, j=0;
unsigned char *arena=(unsigned char *)&(arenas[currarena]);
	chdir(maps);
	if(fp=fopen("fields.map", "rb")) {
		fread(&arenacols, 15, 2, fp);
		fread(&arenas, 21*22, 15, fp);
		fclose(fp);
		while(i<(21*22)) {
			if(*arena>191) (*arena)-=9;
			if(*arena>127) (*arena)-=9;
			if(*arena>63) (*arena)-=9;
			if(*arena) j=1;
			i++; arena++;
		}
	}
	return(j);
}

void savear() {
short i=0;
unsigned char *arena=(unsigned char *)&arenas[currarena];
	while(i<(21*22)) {
		if(*arena>54) (*arena)+=9;
		if(*arena>118) (*arena)+=9;
		if(*arena>182) (*arena)+=9;
		i++; arena++;
	}
	chdir(maps);
	fp=fopen("fields.map", "wb");
	fwrite(&arenacols, 15, 2, fp);
	fwrite(&arenas, 21*22, 15, fp);
	fclose(fp);
}

void ar_paint() {
short i=0;
char *buffer, *reverse;
PXY px;
FDB othello;
	px[0]=((block%11)*26)+356; px[1]=((block/11)<<4);
	px[2]=px[0]+21; px[3]=px[1]+13;
	my_hide_mouse();
	if((!(x&1))&&(block%55)>23&&(!((block%55)&3))) {
		buffer=alloca(308); reverse=alloca(308);
		othello.fd_addr=buffer;
		othello.fd_w=22; othello.fd_h=14;
		px[4]=px[5]=0; px[6]=21; px[7]=13;
		vro_cpyfm(handle, S_ONLY, px, &display, &othello);
		i=0; while(i<308) {
			memcpy(&reverse[i], &buffer[286-i], 22);
			i+=22;
		}
		memcpy(px, &px[4], 8);
		othello.fd_addr=reverse;
	}
	px[4]=x<<4; px[6]=px[4]+21;
	px[5]=(y<<4)+((x&1)<<3)+32; px[7]=px[5]+13;
	screenblit(D_ONLY, px, (i)?&othello:&display);
	my_show_mouse();
	arenas[currarena][x][y]=block;
}

void show_arblock() {
PXY px;
	px[0]=((block%11)*26)+356; px[1]=((block/11)<<4);
	px[2]=px[0]+21; px[3]=px[1]+13;
	px[4]=304; px[5]=0; px[6]=325; px[7]=13;
	screenblit(3, px, &display); 
}

void get_arblock() {
	block=(mx-356)/26+((my>>4)*11);
	show_arblock();
}

void batcolor(short orig) {
unsigned char i[3];
char temp[4];
	sprintf(temp, "%03x", orig&0xfff);
	v_gtext(handle, 512, 336, temp);
	i[0]=(orig&0xf00)>>5; i[1]=(orig&0xf0)>>1; i[2]=(orig&15)<<3;
	Setcolor(0, i); Setpalette();
}


void arstart() {
short i=x, j=block, k=y;
char temp[4];
	Setscreen(1, 0);
	x=0; while(x<21) {
		y=0; while(y<22) {
			block=arenas[currarena][x][y];
			ar_paint(); y++;
		}
		x++;
	}
	sprintf(temp, "%02d", currarena);
	v_gtext(handle, 360, 336, temp);
	v_gtext(handle, 418, 336, faces[face]);
	x=i; block=j; y=k;
	batcolor(arenacols[currarena]);
	Setscreen(0, 0);
}

void new_arena(UCHAR *arena, COORD *here) {
short i, j, k;
BATCOORD *bc=bcoords;
	count=0; check_in(here, 6, 9);
	count=22;
	i=0; while(i<40) {
		k=j=terrains[bc->terr_no].bpict;
		if(terrains[bc->terr_no].type&TALL) k|=64;
		if(terrains[bc->terr_no].type&NOGO) k|=128;
		make_cell(arena, j, k, bc->x, bc->y);
		i++; bc++;
	}
	cut_pillars();
	arenacols[currarena]=terrains[wrld[here->hex][here->cell]].backcolor;
	j=0; while(j<(21*22)) {
		if(*arena>191) (*arena)-=9;
		if(*arena>127) (*arena)-=9;
		if(*arena>63) (*arena)-=9;
		j++; arena++;
	}
}

void do_arena(short curr, COORD *here) {
short option, check, i, j, k, l;
char mess[10];
UCHAR *arena=(UCHAR *)&arenas[curr];
	currarena=curr; block=0;
	my_hide_mouse(); enter_lo();
	loadpcx(arenamap);
	if(!loadar()) new_arena(arena, here);
	show_arblock(); arstart();
	my_show_mouse();
	while(1) {
		option=get_choice();
		if(mx<342&&my>31) {
				check=(mx-4)>>4;
				if(check>=0&&check<21) {
					x=check; check=(check&1)<<2; my-=32;
					if(my>=check&&my<352+check) {
						my_hide_mouse();
						y=(my-check)>>4;
						sprintf(mess, "X:%02d Y:%02d", x, y);
						v_gtext(handle, 16, 12, mess);
						if(option) {
									i=0; while(i<462) {
										if(arena[i]) break;
										i++;
									}
									if(i==462) new_arena(arena, here);
									else memset(arena, block, 462);
									arstart();
						}
						else {
							arenas[currarena][x][y]=block; ar_paint();
						}
						my_show_mouse();
				}
			}
		}
		else if(my>375) break;
		else if(mx>355) {
			if(my<320) get_arblock();
			else if(my>351&&my<368) {
				l=arenacols[currarena]; j=l>>8; k=(l>>4)&15; l&=7;
				if(mx>361&&mx<380) j--;
				if(mx>409&&mx<428) j++;
				if(mx>457&&mx<476) k--;
				if(mx>505&&mx<524) k++;
				if(mx>553&&mx<572) l--;
				if(mx>601&&mx<620) l++;
				arenacols[currarena]=((j&7)<<8)+((k&7)<<4)+(l&7);
				batcolor(arenacols[currarena]);
			}
		}
	}
	savear(); v_clrwk(handle); exit_lo();
	Resetpalette(currcol);
}
