#define	dundef	extern
#include	"newgen.h"

/* Spell area options */
#define FIGHT	1
#define TRAVEL	2
#define CLUSTER	4
#define	MULTI	8
#define	OTHER	16
#define	SELF	32
#define	ENEMY	64

short	wlength, tlength, maxmons, maxhitems;
int	maxsize;
STRING	*usedshapes[60];
FILE *fpin;

void tab() {
char i;
	i=9; fwrite(&i, 1, 1, fp);
}

void lineend() {
char i;
	i=10; fwrite(&i, 1, 1, fp);
}

void number(short i) {
char j[6];
	sprintf(j,"%d", i); fwrite(&j, strlen(j), 1, fp);
}

void numbertab(short i) {
	number(i); tab();
}

void tabno(short i) {
	tab(); number(i);
}

void numberend(short i) {
	number(i); lineend();
}

void lnumber(unsigned int i) {
char j[10];
	sprintf(j,"%u", i); fwrite(&j, strlen(j), 1, fp);
}

void strn(char *n) {
	fwrite(n, strlen(n), 1, fp);
}

void strnspace(char *n) {
	strn(n); strn(" ");
}

void strncol(char *n) {
	strn(n); strn(": ");
}

void strntab(char *n) {
	strn(n); tab();
}

void tabstrn(char *n) {
	tab(); strn(n);
}

void aline(char *n) {
	strn(n); lineend();
}

void tabaline(char *n) {
	tab(); aline(n);
}

void title(char *n) {
	lineend(); tab(); tab(); tab(); tabaline(n);
}

void coord(COORD *x) {
	number((short)x->hex); strn(":"); numbertab((short)x->cell);
}

void spell_uses(char j) {
	strncol("Spell use");
	if(j&FIGHT) strntab("FIGHT");
	if(j&TRAVEL) strntab("TRAVEL");
	if(j&CLUSTER) strntab("CLUSTER");
	if(j&MULTI) strntab("MULTI");
	if(j&OTHER) strn("OTHER");
	if(j&SELF) strn("SELF");
	if(j&ENEMY) strn("ENEMY");
	lineend();
}

void print_flags(char *name, UCHAR locflags) {
short j;
	if(locflags) {
		lineend(); strncol(name);
		j=0; while(j<flagct) {
   		if(locflags&1) strnspace(flag_names[j]);
      	j++; locflags>>=1;
		}
   }
}

void print_item(short i) {
short j;
char *temps;
UCHAR type, human, *vars;
ITEM *ri;
	ri=icurr;
	type=ri->type;
	temps=(human=(type==PERSON||type==FIGHTER||i))?
		(char *)r_temps:(char *)i_temps;
	strntab(ri->name);
	if(human) {
		strncol("Field"); number(ri->battlefield);
	}
	print_flags("DoFlags", ri->doflags);
	print_flags("UnFlags", ri->dontflags);
	lineend();
	if(!i) { strntab(itypes[type]); strncol("Sub"); }
	strntab((char *)(isubs[type][ri->subtype]));
	if((type==PERSON)&(!i)) {
		strncol("Mood"); strntab(peffects[ri->effect]);
	}
	else {
		strncol("Effect"); strntab(effects[ri->effect]);
	}
	if(ri->contents) {
		strncol("Equip"); strntab(holdings[ri->contents].name);
	}
	if(ri->picture) { strncol("Pict"); numbertab((short)ri->picture); }
	if(human) { strncol("Verb"); strn(attacks[ri->locales]); }
	lineend();
	if(!i&&ri->text) { strncol("Text"); numbertab((short)ri->text); }
	strncol(temps); temps+=10; numbertab(ri->cost);
	strncol(temps); temps+=10; numbertab(ri->weight);
	strncol(temps); temps+=20; numbertab((short)ri->use);
	if(human) {
		strncol("Sex"); strntab((ri->backuse) ? "Female" : "Male");
	}
	strncol("Num"); numberend((short)ri->count);
	j=0; vars=&ri->hits; while(j<((human)?15:12)) {
		strncol(temps);
		if((j&3)<3&&j<14) numbertab((short)*vars);
		else numberend((short)*vars);
		j++; vars++; temps+=10;
	}
	lineend();
	if(ri->locales) spell_uses(ri->locales);
}

void print_items() {
short i;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("items.txt", "wb");
	icurr=items;
	title("Listing of items");
	i=0; while(i<icount) {
		print_item(0); icurr++; i++;
	}
	fclose(fp); graf_mouse(ARROW, 0l);
}

void print_counters() {
short i;
COUNTER *rc=counters;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("counters.txt", "wb");
	title("Listing of counters");
	i=0; while(i<cncount) {
		if(rc->name[0]) {
			strntab(rc->name); strncol("Fires");
			if(rc->current) {
				numbertab(rc->fires);
				strncol("Current"); numberend(rc->current);
			}
			else numberend(rc->fires);
		if(rc->effect) {
			strncol("Effect"); strntab(effects[rc->effect]);
			strncol("Power"); numbertab(rc->power);
		}
		if(rc->contents) {
			strncol("Equip"); strntab(holdings[rc->contents].name);
		}
		if(rc->picture) { strncol("Pict"); numbertab((short)rc->picture); }
		}
		if(rc->text) { strncol("Text"); number((short)rc->text); }
		print_flags("Sets flags", rc->sets);
		print_flags("Unsets flags", rc->unsets);
		lineend();
		if(rc->place.cell<HEXSIZE) {
			strnspace("Fires in"); strnspace(worlds[rc->place.world].name);
			strnspace("at cell"); number(rc->place.cell);
			strnspace(" of hex"); number(rc->place.hex);
			lineend();
		}
		rc++; i++;
	}
	fclose(fp); graf_mouse(ARROW, 0l);
}

void print_randoms() {
short i, j, k;
char *l;
MONSTER *rcurr;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("monsters.txt", "wb");
	rcurr=randoms;
	title("Listing of monsters");
	i=0; while(i<rcount) {
		icurr=(ITEM *)rcurr; print_item(1);
		l=rcurr->areas; j=0; while(j<4) {
			if(l[1]) {
				strntab(wtypes[*l]);
				k=0; while(k<8) {
					if(l[1]&(1<<k)) strntab(areas[*l][k]);
					k++;
				}
				lineend();
			}
			j++; l+=2;
		}
		rcurr++; i++; lineend();
	}
	fclose(fp); graf_mouse(ARROW, 0l);
}

void print_texts() {
short i, j, k;
char *sofar;
TALK *tcurr;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("texts.txt", "wb");
	title("Listing of texts");
	tlength=tcount-6; tcurr=texts; i=0; while(i<tcount) {
		lineend(); strnspace("Text"); numberend(i);
		j=0; while(j<16) {
			if(tcurr->used[j]) {
				sprintf(backplane, "Line %d	", j);
				strcat(backplane, tcurr->lines[j]);
				if(i>4) tlength+=strlen(tcurr->lines[j])+2;
				sofar=backplane;
				while(strlen(sofar)>75) {
					strncpy(myline, sofar, k=75); while(myline[--k]!=32);
					myline[++k]=0; sofar+=k; aline(myline); 
				}
				aline(sofar);
			}
			j++;
		}
		i++; tcurr++;
	}
	fclose(fp); graf_mouse(ARROW, 0l);
}

void holding(char *where, int which) {
	if(hcurr->hicounts[which]) {
		maxhitems++; tabaline(where); aline(items[hcurr->hitems[which]].name);
	}
}

void print_treas() {
short i, j, k;
TREAS *hcurr;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	maxhitems=0;
	fp=fopen("baggages.txt", "wb");
	title("Listing of baggages");
	hcurr=holdings;
	i=0; while(i<hcount) {
		lineend();
		strntab(hcurr->name); strncol("Plural"); aline(hcurr->plural);
		holding("Right hand", 0);
		holding("Left hand", 1);
		holding("Wear", 2);
		holding((char *)isubs[5][0], 3);
		holding((char *)isubs[5][1], 4);
		holding((char *)isubs[5][2], 5);
		aline("Backpack");
		j=6; while(j<20) {
			if(hcurr->hicounts[j]) {
					maxhitems++; strnspace(items[hcurr->hitems[j]].name);
					numberend(hcurr->hicounts[j]);
				}
				j++;
		}
		if(hcurr->spellbook) {
			aline("Spells known");
			k=j=0; while(j<MAXSPELLS) {
				if(hcurr->spellbook&((long)(1<<j))) {
					strn(spellbook[j].name); k++;
					if(!(k%5)) lineend(); else tab();
				}
				j++;
			}
			lineend();
		}
		i++; hcurr++;
	}
	strncol("Total items"); numbertab(maxhitems);
	strncol("Unused"); numberend(icount-maxhitems);
	strncol("Average per holding");
	numberend((short)((maxhitems+hcount)/hcount));
	fclose(fp); graf_mouse(ARROW, 0l);
}

void do_text_use() {
short j, term, used;
ITEM *match;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("textuse.txt", "wb");
	title("Texts used");
	term=8; while(term<tcount) {
		lineend(); strncol("Text"); numberend(term);
		match=items; used=j=0; while(j<icount) {
			if(match->text==term) {
            used=1;
				tab(); strnspace(match->name); numberend(j);
			}
			match++; j++;
		}
      j=0; while(j<cncount) {
			if(counters[j].text==term) {
            used=1;
				tab(); strnspace(counters[j].name); numberend(j);
			}
         j++;
		}
		if(!used) aline("Not used.");
		term++;
	}
	fclose(fp); graf_mouse(ARROW, 0l);
}

void do_pict_use() {
short j, prev, term, used;
ITEM *icurr;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("pictuse.txt", "wb");
	title("Graphics used");
	term=1; while(term<pictct) {
		lineend(); strncol("Graphic"); numberend(term);
		icurr=items; prev=j=0; while(j<icount) {
			if(icurr->picture==term) {
				if(!prev) {
					used=prev=1; aline("Items");
				}
				tabaline(icurr->name);
			}
			icurr++; j++;
		}
		if(!used) aline("Not used.");
		term++;
	}
	fclose(fp); graf_mouse(ARROW, 0l);
}

void do_treas_use() {
short j, prev, term, used;
ITEM *icurr;
MONSTER *rcurr;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("baguse.txt", "wb");
	title("Baggages used");
	term=1; while(term<hcount) {
		lineend(); strnspace("Baggage"); number(term); strnspace(":");
		aline(holdings[term].name);
		used=0;
		icurr=items; prev=j=0; while(j<icount) {
			if(icurr->contents==term) {
				if(!prev) {
					used=prev=1; aline("Items");
				}
				tabaline(icurr->name);
			}
			icurr++; j++;
		}
		rcurr=randoms; prev=j=0; while(j<rcount) {
			if(rcurr->contents==term) {
				if(!prev) {
					used=prev=1; aline("Randoms");
				}
				tabaline(rcurr->name);
			}
			rcurr++; j++;
		}
		if(!used) aline("Not used.");
		term++;
	}
	fclose(fp); graf_mouse(ARROW, 0l);
}

void print_spells() {
short i;
SPELL *scurr;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("spells.txt", "wb");
	scurr=spellbook;
	title("Listing of spells");
	i=0; while(i<spellct) {
		lineend();aline(scurr->name);
		strncol("Effect"); strntab(effects[scurr->effect]);
		strncol("Verb"); strntab(scurr->verb);
		strncol("Cost"); numbertab((short)scurr->cost);
		strncol("Power"); numbertab((short)scurr->power);
		strncol("Range"); numberend((short)scurr->range);
		spell_uses(scurr->locales);
		i++; scurr++;
	}
	fclose(fp); graf_mouse(ARROW, 0l);
}

void do_item_use() {
short i=1, j, k, prev;
WORLD *wcurr;
	chdir(reports);
	fp=fopen("itemuse.txt", "wb");
	while(i<icount) {
		prev=0; aline(items[i].name);
		hcurr=holdings; j=0; while(j<hcount) {
			k=0; while(k<20) {
				if(hcurr->hicounts[k]&&(hcurr->hitems[k]==i)) {
               if(!prev) aline("Baggages");
					prev=1; tabaline(hcurr->name); break;
				}
				k++;
			}
			j++; hcurr++;
		}
      wcurr=worlds; j=0; while(j<wcount) {
         k=0; while(k<MAXWITEMS) {
            if(wcurr->conlocs[k].count&&wcurr->conlocs[k].item==i) {
               if(prev<2) aline("Worlds");
					prev=1; tabaline(wcurr->name); break;
            }
            k++;
         }
			j++; wcurr++;
      }
		if(!prev) aline("Unused");
		i++; lineend();
	}
	fclose(fp);
}

void print_worlds() {
short i, j, k, l, type, minlev, some, thi, tlo;
GATE *gate;
TERRAIN *terr;
WORLD *wcurr;
MONSTER *rcurr;
	graf_mouse(HOURGLASS, 0l);
	chdir(reports);
	fp=fopen("worlds.txt", "wb");
	title("Listing of worlds");
	wcurr=worlds;
	wlength=wcount*48;
	maxsize=i=0; while(i<wcount) {
		lineend(); minlev=(((wcurr->states&224)>>2)+8)<<4;
		numbertab(i); aline(wcurr->name);
		strncol("Type"); strntab(wtypes[type=(wcurr->type&15)]);
		strncol("Map"); strntab(wcurr->mapname);
		strncol("Size"); numbertab((short)wcurr->size);
		strncol("Step Time"); numberend((short)wcurr->mins);
		strncol("Music"); strntab(songs[wcurr->tune]);
		strntab((wcurr->states&16) ? "Light" : "Dark");
		sprintf(myline, "Danger %d", wcurr->states&3); strntab(myline);
		if((wcurr->states&12)==12) aline("Village");
		else if(wcurr->states&4) aline("Tiled");
		else aline("Looped");
		aline("Connections");
		gate=wcurr->gates; j=0; while(j<32) {
			if(gate->exit.cell<HEXSIZE) {
				wlength+=sizeof(GATE);
				strntab(worlds[gate->entry.world].name);
				strnspace("Leaves"); coord(&(gate->exit));
				strnspace("For"); coord(&(gate->entry));
				if((k=gate->exittext)&15) {
					strncol("Extext"); numbertab((short)(k&15));
				}
				if((l=gate->entrytext)&15) {
					strncol("Entext"); number((short)(l&15));
				}
				lineend();
				strntab((k&128)?"Optional":"Forced");
				aline((l&128)?"Surprise":"Warning");
			}
			j++; gate++;
		}
		lineend();
		aline("Contents");
		j=0; while(j<MAXWITEMS) {
			if(wcurr->conlocs[j].count) {
				coord((COORD *)&(wcurr->conlocs[j].used));
				icurr=&(items[wcurr->conlocs[j].item]); print_item(0);
			}
			j++;
		}
		aline("Blocks");
		terr=wcurr->blocks; tlo=1000;
		thi=j=k=0; while(j<48) {
			if(terr->t_no==j) {
				wlength+=sizeof(TERRAIN);
				numbertab(j);
				strcpy(myline, shapenames[terr->sh_no]); strntab(myline);
				text_btype(myline, terr->type); strntab(myline);
				strntab(effects[terr->effect]);
				strntab(areas[type][terr->m_type]);
				strnspace("Level"); numbertab((short)(minlev+(terr->level<<4)));
				strnspace("Transit time"); numbertab((short)terr->time);
				if((l=terr->change_to)<48) {
					if(terr->change_from) {
						strnspace("Changes Blk"); number((short)(terr->change_from));
						strnspace(" to"); numbertab(l);
					}
				}
				else if(l==48) strntab("Ends game when reached");
				else { strnspace("Rotates view by"); numbertab((short)(l-48)); }
				print_flags("Flags", terr->flags);
				lineend();
            l=0; while(l<k) {
					if(usedshapes[l]==shapenames[terr->sh_no]) break;
					l++;
				}
				if(l==k) usedshapes[k++]=shapenames[terr->sh_no];
				if(!(terr->type&NOGO)) {
					if(terr->level>thi) thi=terr->level;
					if(terr->level<tlo) tlo=terr->level;
				}
			}
			terr++; j++;
		}
		lineend();
		aline("Shapes");
		l=0; while(l<k) {
			strn(usedshapes[l++]);
			if(l%5) tab(); else lineend();
		}
		if(k%5) lineend();
		lineend();
		rcurr=randoms; thi=minlev+(thi<<4); minlev+=(tlo<<4);
		some=j=0; while(j<rcount) {
			if(((rcurr->areas[0]==type&&(rcurr->areas[1]))||
				(rcurr->areas[2]==type&&(rcurr->areas[3]))||
				(rcurr->areas[4]==type&&(rcurr->areas[5]))||
				(rcurr->areas[6]==type&&(rcurr->areas[7])))) {
				if(!some) aline("Randoms");
				if(rcurr->expvalue*rcurr->count>=thi) strn("*");
					strnspace(rcurr->name);
					numbertab((rcurr->expvalue*rcurr->count*100)/minlev);
				if((some%3)==2) lineend();
				some++;
			}
			j++; rcurr++;
		}
		if(maxmons<some) maxmons=some;
		lineend();
		if(some) {
			sprintf(myline, "Min level %d", minlev); strntab(myline);
			sprintf(myline, "Max level %d", thi); aline(myline);
		}
		i++; wcurr++;
	}
	lineend(); strncol("World length"); number(wlength);
	fclose(fp); graf_mouse(ARROW, 0l);
}

void uselines(char *stitle, short create) {
	if(!create) {
		while(!strstr(myline, stitle)) {
			fgets(myline, 80, fpin);
			if(myline[0]=='!') strn(myline);
		}
	}
	title(stitle);
}

void save_global() {
short i, j, create=0;
char newhex[FMSIZE];
	strcpy(newhex, hexdir);
	fpin=fopen(hexdir, "rb");
	if(!fpin) create=1;
	else newhex[strlen(newhex)-1]='y';
	fp=fopen(newhex, "wb");
	uselines("[NAME]", create); tabaline(gamename);
	uselines("[ITYPES]", create);
	i=0; while(i<itypect) {
		tabstrn(itypes[i++]);
		if(i==6) lineend();
	}
   lineend();
	uselines("[SUBTYPES]", create);
	i=0; while(i<itypect) {
		j=0; while(j<subtypect[i]) {
			tabstrn(isubs[i][j]);
			if(j==6) lineend();
         j++;
		}
		lineend(); tabaline("---"); i++;
	}
   lineend();
	uselines("[WORLDS]", create);
	i=0; while(i<wtypect) {
		tabstrn(wtypes[i++]);
		if(i==6) lineend();
	}
   lineend();
	uselines("[AREAS]", create);
	i=0; while(i<wtypect) {
		j=0; while(j<r_areas[i]) {
			tabstrn(areas[i][j]);
			if(j==6) lineend();
         j++;
		}
		lineend(); tabaline("---"); i++;
	}
   lineend();
	uselines("[TIMES]", create);
	tabno(minutes); tabno(hours); tabno(days); tabno(months);
	tabno(bed); tabno(wake); lineend();
	uselines("[FLAGS]", create);
	i=0; while(i<flagct) {
		tabstrn(flag_names[i++]);
		if(i==6) lineend();
	}
   lineend();
	uselines("[ATTACKS]", create);
	i=0; while(i<attack) {
		tabstrn(attacks[i]);
		if(i==6) lineend();
		i++;
	}
   lineend();
	uselines("[MUSIC]", create);
	i=0; while(i<songct) tabaline(songs[i++]);
   lineend();
	uselines("[FOLDERS]", create);
	i=0; while(i<7) tabaline(folders[i++]);
	/*tabaline(unhome(lists));
	tabaline(unhome(pictures));
	tabaline(unhome(maps));
	tabaline(unhome(shapes));
	tabaline(unhome(screens));
	tabaline(savedir);*/
	lineend();
	uselines("[VARIABLES]", create);
	tab(); lnumber(explev); tabno(starthour); tabno(startday);
	tabno(startmonth); tabno(startyear); tabno(hostility);
	tabno(vicious); tabno(quickfight); tabno(slowfight);
	lineend();
	uselines("[MONTHS]", create);
	i=0; while(i<months) {
		tabstrn(m_names[i]); if(i==6) lineend();
		i++;
	}
   lineend();
	uselines("[SCREENS]", create);
	tabaline(smallmap); tabaline(midmap); tabaline(bigmap);
	tabaline(arenamap); tabaline(scenery);
	if(!create) fclose(fpin);
	fclose(fp);
}

void make_ini() {
short i;
	inimake=1; save_all();
	chdir(reports);
	fp=fopen("game.ini", "wb");
	title("[Name]"); tabaline(gamename);
	lineend();
	title("[Times]");
	tabno(minutes); tabno(hours); tabno(days); tabno(months);
	tabno(bed); tabno(wake); lineend();
	title("[Folders]");
	tabaline(folders[6]);
	tabaline(folders[1]);
	tabaline(folders[3]);
	tabaline(folders[0]);
	tabaline(folders[2]);
	lineend();
	title("[Attacks]");
	i=0; while(i<attack) {
		tabstrn(attacks[i]);
		if(i==6) lineend();
		i++;
	}
	lineend();
	title("[Ornaments]");
	i=0; while(i<subtypect[5]) {
		tabstrn((char *)isubs[5][i++]);
	}
	lineend();
	title("[Variables]");
	tab(); lnumber(explev); tabno(starthour); tabno(startday);
	tabno(startmonth); tabno(startyear); tabno(hostility);
	tabno(vicious); tabno(quickfight); tabno(slowfight);
	lineend();
	title("[Months]");
	i=0; while(i<months) {
		tabstrn(m_names[i]); if(i==6) lineend();
		i++;
	}
	lineend();
	title("[Music]");
	i=0; while(i<songct) tabaline(songs[i++]);
	fclose(fp);
	inimake=0;
}
