#include	<stdlib.h>
#include	<stdio.h>
#include	<dirent.h>
#include	"osbind.h"
#include	"vdi.h"
#include	"aes.h"
#define STRING	char
#define ROTATE	unsigned	char
#define FLAG	unsigned short
#define UCHAR	unsigned char

typedef	short	PXY[8];

#define UP	0
#define RUP	1
#define RDOWN	2
#define DOWN	3
#define LDOWN	4
#define LUP	5

#define	B_FULL	0
#define	B_HALF	1
#define	B_SQUEEZE	2
#define	B_MASK	3
#define	B_COPY	4

#define	EDGE	10
#define	HEXSIZE 3*EDGE*EDGE
#define	MYLIMIT	14
#define	MAXFRAMES	20
#define	MAXSPRITES	104
#define	MAXPICTS  128
#define	MAXITEMS	512

typedef	struct	LIBHEAD {
	int	size;
	unsigned	short	type;
	short	images;
} LIBHEAD;
statdef	LIBHEAD	libhead;

typedef	struct	BLTHEAD {
	int	size;
	short	type;
	UCHAR	images;
	UCHAR	repeat;
	UCHAR	pallength;
	UCHAR	cycle_flag;
	UCHAR	blanks[2];
} BLTHEAD;
statdef	BLTHEAD	blthead, *currblt;

typedef	struct	CYCLE {
	char	direction;
	UCHAR	speed;
	UCHAR	start;
	UCHAR	length;
}	CYCLE;
statdef	CYCLE	*cycles, *currcycle;

typedef	struct	PICHEAD {
	short	width;
	UCHAR	height;
	char	vdisp, hdisp;
	char	mode;
}	PICHEAD;

statdef	PICHEAD	picheads[20], *currpichead;

typedef struct  WITEM {
   	short	item;
      short	count;
		UCHAR	used;
		UCHAR	hex;
		short	cell;
}	WITEM;


#define	MAXHEADS 64

typedef	struct	HEADER {
		char	type;
		char	shapecount;
		unsigned short	offsets[16];
		unsigned short	shapesize;
		unsigned	char	*shapes;
		PXY		pxes[16];
	}	HEADER;

statdef	HEADER	headers[MAXHEADS];

typedef struct  ITEM {
		STRING  name[25];
		ROTATE  type;
		ROTATE  subtype;
		ROTATE  effect;
		short	cost;	/*purse*/
		short	weight;	/*expvalue*/
		ROTATE  contents;
		ROTATE  text;
		UCHAR	count;
		UCHAR	use; /*repeat count for hostile*/
		UCHAR	backuse; /*sex for person*/
		UCHAR	hits;	/*start of variables*/
		UCHAR	protection;
		UCHAR	cover;
		UCHAR	shield;
		UCHAR	power;
		UCHAR	skill;
		UCHAR	speed;
		UCHAR	magres;
		UCHAR	lighting;	/*vigor in person*/
		UCHAR	eating;	/*mobility in person*/
		UCHAR	code;	/*used for locks & guns; sprite in hostile*/
		UCHAR	range;	/*weightrat in person*/
		UCHAR	backeating;	/*skillrat in person*/
		UCHAR	speedrat;
		UCHAR	hitrat;
		UCHAR	locales;	/*where magical effects work; verb in hostiles*/
		UCHAR	battlefield;
		ROTATE  picture;
      UCHAR	spare;
      FLAG	doflags;
      FLAG	dontflags;
	}	ITEM;

typedef struct  MONSTER {
		STRING  name[25];
		ROTATE  type;
		ROTATE  subtype;	/*not used*/
		ROTATE  effect;
		short	purse;
		short	expvalue;
		ROTATE  contents;
		ROTATE  text;	/*not used*/
		UCHAR	count;
		UCHAR	frequency;
		UCHAR	sex;
		UCHAR	hits;	/*start of variables*/
		UCHAR	protection;
		UCHAR	cover;
		UCHAR	shield;
		UCHAR	power;
		UCHAR	skill;
		UCHAR	speed;
		UCHAR	magres;
		UCHAR	vigor;
		UCHAR	mobility;
		UCHAR	sprite;
		UCHAR	strength;	/*4 basic*/
		UCHAR	endurance;
		UCHAR	dexterity;
		UCHAR	intelligence;
		ROTATE	verb;
		UCHAR	battlefield; /*not used*/
		UCHAR	areas[8];
	}	MONSTER;

statdef	int	handle;
statdef	short	*foewear, sprct, sprcol, basewidth, baseheight, timer,
	line_no, junk, changeimage, frame, paldisp, count, hostility, vicious,
	minutes, hours, days, months, bed, wake, starthour, startday, startmonth,
	startyear, slowfight, quickfight, backct, pictct, shapecount;
statdef	UCHAR	*sofar, *stats, *base, *images[20], *bltpal, palette[768],
   viewpalette[768];
statdef	ITEM	*wear, *items;

typedef	struct	BATCOORD {
	short	terr_no;
	char	x, y;
} BATCOORD;

typedef	struct	COORD {
		char	world;
		char	hex;
		short	cell;
	}	COORD;

statdef	BATCOORD	bcoords[40];
statdef	UCHAR	*field, palindex[256], shapeuse[MAXHEADS],
   spalette[768], *sprites[MAXSPRITES], *backs[MYLIMIT],
   *picts[MAXPICTS];
statdef	char	spritesizes[MAXSPRITES], wrld[108][300], handy[256],
	shapes[256], selfile[FNSIZE], myline[82], home[256], gamename[80],
	stateffs[256], m_names[16][20], shapenames[][20], songs[12][FMSIZE],
	attacks[16][10];
statdef	FILE	*fp;

statdef	FDB	display, behind;

statdef	int	explev;


